#include "eliminate.h"
#include "qcount.h"

Node * eliminateLinearConstraintsBySquareForm(int varsize, Node * phi_constraints, Node * linearConstraints, int * varlist2_fphionly)
{
	//printf("Examine :\n");
	//printSystem(phi_constraints);
	int ** countboard_up = (int **)malloc(sizeof(int *)*(varsize + 2));
	int ** countboard_down = (int **)malloc(sizeof(int *)*(varsize + 2));

	for (int i = 0; i < varsize + 2; i++){
		countboard_up[i] = (int *)malloc(sizeof(int)*(varsize + 2));
		countboard_down[i] = (int *)malloc(sizeof(int)*(varsize + 2));
		for (int j = 0; j < varsize + 2; j++){
			countboard_up[i][j] = 0;
			countboard_down[i][j] = 1;
		}
	}

	int thisx = 0, thisy = 0;
	int * qresult;
	Node * phi_square_record = linearConstraints;
	Node * square_ptr;

	Node * newphiconstraints = (Node *)malloc(sizeof(Node));

	newphiconstraints->a = (int *)malloc((phi_constraints->a[0] + 2)*sizeof(int));
	newphiconstraints->a[0] = phi_constraints->a[0];
	for (int i = 1; i <= phi_constraints->a[0]; i++){
		newphiconstraints->a[i] = 0;
	}
	newphiconstraints->b = (int **)malloc((phi_constraints->a[0] + 1) * sizeof(int *));
	for (int i = 0; i < phi_constraints->a[0]; i++){
		newphiconstraints->b[i] = (int *)malloc(((phi_constraints->a[i + 1]>0 ? 2 * phi_constraints->a[i + 1] : -2 * phi_constraints->a[i + 1]) + 1) * sizeof(int));
	}
	newphiconstraints->c = (double **)malloc((phi_constraints->a[0] + 1)*sizeof(double *));
	for (int i = 0; i < (phi_constraints->a[0]); i++){
		newphiconstraints->c[i] = (double *)malloc(((phi_constraints->a[i + 1]>0 ? phi_constraints->a[i + 1] : -phi_constraints->a[i + 1]) + 1) * sizeof(double));
	}

	for (int i = 1; i <= phi_constraints->a[0]; i++){

		for (int j = 1; j <= varsize + 1; j++){
			for (int k = j; k <= varsize + 1; k++){
				countboard_up[j][k] = 0;
				countboard_down[j][k] = 1;
			}
		}
		if (phi_constraints->a[i] > 0){
			//phi_constraintscountboard
			for (int j = 0; j < phi_constraints->a[i]; j++){
				thisx = phi_constraints->b[i - 1][2 * j] + 1;
				thisy = phi_constraints->b[i - 1][2 * j + 1] + 1;
				if (thisx == thisy){
					qresult = ftoq(phi_constraints->c[i - 1][j]);
				}
				else{
					qresult = ftoq(phi_constraints->c[i - 1][j] / 2);
				}
				countboard_up[thisx][thisy] = qresult[0];
				countboard_down[thisx][thisy] = qresult[1];
			}
		}
		else{
			//phi_constraintscountboard
			for (int j = 0; j < -phi_constraints->a[i]; j++){
				thisx = phi_constraints->b[i - 1][2 * j] + 1;
				thisy = phi_constraints->b[i - 1][2 * j + 1] + 1;
				if (thisx == thisy){
					qresult = ftoq(phi_constraints->c[i - 1][j]);
				}
				else{
					qresult = ftoq(phi_constraints->c[i - 1][j] / 2);
				}
				countboard_up[thisx][thisy] = qresult[0];
				countboard_down[thisx][thisy] = qresult[1];
			}
		}
		for (int j = 1; j <= varsize + 1; j++){
			for (int k = 1; k < j; k++){
				countboard_up[j][k] = countboard_up[k][j];
				countboard_down[j][k] = countboard_down[k][j];
			}
		}

		//printf("\ncount board :\n");
		//for (int i = 1; i <= varsize + 1; i++){
		//	for (int j = 1; j <= varsize + 1; j++){
		//		printf("%d/%d  ", countboard_up[i][j], countboard_down[i][j]);
		//	}
		//	printf("\n");
		//}
		//printf("\ncount board :\n");
		//for (int i = 1; i <= 8; i++){
		//	for (int j = 1; j <= 8; j++){
		//		printf("%d/%d  ", countboard_up[i][j], countboard_down[i][j]);
		//	}
		//	printf("\n");
		//}

		int temp = 0;
		int tempup = 0, tempdown = 0;
		square_ptr = phi_square_record;
		while (square_ptr != NULL){
			while (square_ptr->b[0][varlist2_fphionly[temp]] == 0){
				temp++;
			}
			int temp_var = varlist2_fphionly[temp];
			if (temp_var == -1){
				square_ptr = square_ptr->next;
				continue;
			}
			//
			if (countboard_up[temp_var][temp_var] != 0){
				int mc_up = countboard_up[temp_var][temp_var];
				int mc_down = countboard_down[temp_var][temp_var];
				for (int j = 1; j <= varsize + 1; j++){
					for (int k = 1; k <= varsize + 1; k++){
						if (k < j){
							countboard_up[j][k] = countboard_up[k][j];
							countboard_down[j][k] = countboard_down[k][j];
						}
						else{
							tempup = mc_up * square_ptr->b[0][j] * square_ptr->b[0][k];
							tempdown = mc_down * square_ptr->b[1][j] * square_ptr->b[1][k];
							int a = gcd(tempup, tempdown);
							tempup = tempup / a;
							tempdown = tempdown / a;
							qresult = fraction_add(countboard_up[j][k], countboard_down[j][k], -tempup, tempdown);
							countboard_up[j][k] = qresult[0];
							countboard_down[j][k] = qresult[1];
						}
					}
				}
			}
			//printf("\n\n");
			//for (int i = 1; i <= varsize + 1; i++){
			//	for (int j = 1; j <= varsize + 1; j++){
			//		printf("%d/%d  ", countboard_up[i][j], countboard_down[i][j]);
			//	}
			//	printf("\n");
			//}
			//printf("\ncount board :\n");
			//for (int i = 1; i <= 8; i++){
			//	for (int j = 1; j <= 8; j++){
			//		printf("%d/%d  ", countboard_up[i][j], countboard_down[i][j]);
			//	}
			//	printf("\n");
			//}
			//һ
			for (int kk = 1; kk <= varsize + 1; kk++){
				if (countboard_up[kk][temp_var] != 0){
					int mc_up = countboard_up[kk][temp_var];
					int mc_down = countboard_down[kk][temp_var];
					for (int j = 1; j <= varsize + 1; j++){
						if (j == kk){
							tempup = 2 * mc_up * square_ptr->b[0][j];
						}
						else{
							tempup = mc_up * square_ptr->b[0][j];
						}
						tempdown = mc_down * square_ptr->b[1][j];
						int a = gcd(tempup, tempdown);
						tempup = tempup / a;
						tempdown = tempdown / a;
						qresult = fraction_add(countboard_up[kk][j], countboard_down[kk][j], -tempup, tempdown);
						countboard_up[kk][j] = qresult[0];
						countboard_down[kk][j] = qresult[1];
					}
					for (int j = 1; j <= varsize + 1; j++){
						countboard_up[j][kk] = countboard_up[kk][j];
						countboard_down[j][kk] = countboard_down[kk][j];
					}
				}

			}
			//printf("\n\n");
			//for (int i = 1; i <= varsize + 1; i++){
			//	for (int j = 1; j <= varsize + 1; j++){
			//		printf("%d/%d  ", countboard_up[i][j], countboard_down[i][j]);
			//	}
			//	printf("\n");
			//}
			//printf("\ncount board :\n");
			//for (int i = 1; i <= 8; i++){
			//	for (int j = 1; j <= 8; j++){
			//		printf("%d/%d  ", countboard_up[i][j], countboard_down[i][j]);
			//	}
			//	printf("\n");
			//}
			square_ptr = square_ptr->next;
		}

		//printf("\n\n");
		//for (int i = 1; i <= varsize + 1; i++){
		//	for (int j = 1; j <= varsize + 1; j++){
		//		printf("%d/%d  ", countboard_up[i][j], countboard_down[i][j]);
		//	}
		//	printf("\n");
		//}

		int temp_consnum = 0;
		for (int j = 1; j <= varsize + 1; j++){
			for (int k = j; k <= varsize + 1; k++){
				if (countboard_up[j][k] != 0){
					newphiconstraints->b[i - 1][2 * temp_consnum] = j - 1;
					newphiconstraints->b[i - 1][2 * temp_consnum + 1] = k - 1;
					if (j == k){
						newphiconstraints->c[i - 1][temp_consnum] = (double)countboard_up[j][k] / (double)countboard_down[j][k];
					}
					else{
						newphiconstraints->c[i - 1][temp_consnum] = 2.0 * (double)countboard_up[j][k] / (double)countboard_down[j][k];
					}

					temp_consnum++;
				}
			}
		}
		if (temp_consnum == 0){
			newphiconstraints->b[i - 1][0] = 0;
			newphiconstraints->b[i - 1][1] = 0;
			newphiconstraints->c[i - 1][0] = 0;
			if (phi_constraints->a[i] > 0){
				newphiconstraints->a[i] = 1;
			}
			else{
				newphiconstraints->a[i] = -1;
			}
		}
		else{
			if (phi_constraints->a[i] > 0){
				newphiconstraints->a[i] = temp_consnum;
			}
			else{
				newphiconstraints->a[i] = -temp_consnum;
			}
			temp_consnum = 0;
		}

	}
	//printSystem(newphiconstraints);

	//ȥ
	Node * newphiconstraints2 = (Node *)malloc(sizeof(Node));
	newphiconstraints2->a = (int *)malloc((phi_constraints->a[0] + 3)*sizeof(int));
	newphiconstraints2->a[0] = 0;
	for (int i = 1; i <= phi_constraints->a[0]; i++){
		newphiconstraints2->a[i] = 0;
	}
	newphiconstraints2->b = (int **)malloc((phi_constraints->a[0] + 2) * sizeof(int *));
	for (int i = 0; i < phi_constraints->a[0]; i++){
		newphiconstraints2->b[i] = (int *)malloc(((phi_constraints->a[i + 1]>0 ? 2 * phi_constraints->a[i + 1] : -2 * phi_constraints->a[i + 1]) + 1) * sizeof(int));
	}
	newphiconstraints2->c = (double **)malloc((phi_constraints->a[0] + 1)*sizeof(double *));
	for (int i = 0; i < (phi_constraints->a[0]); i++){
		newphiconstraints2->c[i] = (double *)malloc(((phi_constraints->a[i + 1]>0 ? phi_constraints->a[i + 1] : -phi_constraints->a[i + 1]) + 1) * sizeof(double));
	}

	int temp_iter = 0;
	//output of show
	//printf("phi constraints:\n");
	//output of show

	bool phi_ok = true;
	for (int i = 0; i < newphiconstraints->a[0]; i++){
		if (newphiconstraints->a[i + 1] == 1 && newphiconstraints->b[i][0] == 0 && newphiconstraints->b[i][1] == 0){
			//output of show
			//printf("%.6lf >= 0\n", newphiconstraints->c[i][0]);
			//output of show
			if (newphiconstraints->c[i][0] >= 0){
				continue;
			}
			else{
				phi_ok = false;
				continue;
			}
		}
		if (newphiconstraints->a[i + 1] == -1 && newphiconstraints->b[i][0] == 0 && newphiconstraints->b[i][1] == 0){
			//output of show
			//printf("%.6lf > 0\n", newphiconstraints->c[i][0]);
			//output of show
			if (newphiconstraints->c[i][0] > 0){
				continue;
			}
			else{
				phi_ok = false;
				continue;
			}
		}
		newphiconstraints2->a[0]++;
		newphiconstraints2->a[temp_iter + 1] = newphiconstraints->a[i + 1];
		if (newphiconstraints->a[i + 1] > 0){
			for (int j = 0; j < 2 * newphiconstraints->a[i + 1]; j++){
				newphiconstraints2->b[temp_iter][j] = newphiconstraints->b[i][j];
			}
			for (int j = 0; j < newphiconstraints->a[i + 1]; j++){
				newphiconstraints2->c[temp_iter][j] = newphiconstraints->c[i][j];
			}
		}
		else{
			for (int j = 0; j < -2 * newphiconstraints->a[i + 1]; j++){
				newphiconstraints2->b[temp_iter][j] = newphiconstraints->b[i][j];
			}
			for (int j = 0; j < -newphiconstraints->a[i + 1]; j++){
				newphiconstraints2->c[temp_iter][j] = newphiconstraints->c[i][j];
			}
		}

		temp_iter++;
	}

	if (phi_ok == false){
		return NULL;
	}

	//printSystem(newphiconstraints2);


	// 
	for (int i = 0; i < newphiconstraints2->a[0]; i++){
		phi_constraints->a[i + 1] = newphiconstraints2->a[i + 1];
		free(phi_constraints->b[i]);
		phi_constraints->b[i] = newphiconstraints2->b[i];
		free(phi_constraints->c[i]);
		phi_constraints->c[i] = newphiconstraints2->c[i];
	}

	return newphiconstraints2;
}


Node * eliminateLinearConstraintsByEqualForm(int varsize, Node * phi_constraints, Node * equal_constraints, int * varlist2_fphionly)
{
	Node * square_ptr = NULL;
	
	square_ptr = (Node *)malloc(sizeof(Node));
	square_ptr->b = (int **)malloc(sizeof(int *)* 2);
	square_ptr->b[0] = (int *)malloc(sizeof(int)* (varsize + 2));
	square_ptr->b[1] = (int *)malloc(sizeof(int)* (varsize + 2));
	for (int i = 0; i < varsize + 2; i++){
		square_ptr->b[0][i] = 0;
		square_ptr->b[1][i] = 1;
	}
	int temp_num = 0;
	for (int j = 0; j < equal_constraints->a[1]; j++){
		if (equal_constraints->b[0][2 * j + 1] == varlist2_fphionly[0] - 1){
			temp_num = j;
			break;
		}
	}
	int * qresult = ftoq(equal_constraints->c[0][temp_num]);
	square_ptr->b[0][0] = qresult[0];
	square_ptr->b[1][0] = qresult[1];
	int term = equal_constraints->a[1] > 0 ? equal_constraints->a[1] : -equal_constraints->a[1];
	for (int j = 0; j < term; j++){
		int varNum = equal_constraints->b[0][2 * j + 1] + 1;
		qresult = ftoq(equal_constraints->c[0][j] / equal_constraints->c[0][temp_num]);
		square_ptr->b[0][varNum] = qresult[0];
		square_ptr->b[1][varNum] = qresult[1];
		free(qresult);
	}
	square_ptr->next = NULL;
	//printSquareSystem(square_ptr, varsize);
	Node * re = eliminateLinearConstraintsBySquareForm(varsize, phi_constraints, square_ptr, varlist2_fphionly);
	
	return re;
}

void VariableReplacement(Node * phi_constraints, int varNum1, int varNum2)
{
	int term;
	for (int i = 0; i < phi_constraints->a[0]; i++){
		term = phi_constraints->a[i + 1]>0 ? phi_constraints->a[i + 1] : -phi_constraints->a[i + 1];
		for (int j = 0; j < 2 * term; j++){
			if (phi_constraints->b[i][j] == varNum1) {
				phi_constraints->b[i][j] = varNum2;
			}
		}
	}
	return;
}
