#include <stdlib.h>
#include <stdio.h>
#include <math.h>
//#include <time.h>
#include "usesdp.h"
#include "declarations.h"

int main() {

	int ** a = (int **)malloc(4 * sizeof(int *));
	a[1] = (int *)malloc(4 * sizeof(int));
	a[2] = (int *)malloc(4 * sizeof(int));
	a[3] = (int *)malloc(4 * sizeof(int));
	
	a[1][1] = -1;
	a[1][2] = 0;
	a[1][3] = 0;
	a[2][2] = -1;
	a[2][3] = 1;
	a[3][3] = -1;


	struct blockmatrix C, X;
	double *b;
	struct constraintmatrix *constraints;

	struct blockmatrix Z;
	double *y;
	double pobj, dobj;

	struct sparseblock *blockptr;

	int ret;

	C.nblocks = 2;
	C.blocks = (struct blockrec *)malloc(3 * sizeof(struct blockrec));
	if (C.blocks == NULL)
	{
		printf("Couldn't allocate storage for C!\n");
		exit(1);
	};

	C.blocks[1].blockcategory = DIAG;
	C.blocks[1].blocksize = 1;
	C.blocks[1].data.vec = (double *)malloc((1 + 1)* sizeof(double));
	if (C.blocks[1].data.vec == NULL)
	{
		printf("Couldn't allocate storage for C!\n");
		exit(1);
	};

	/*
	* Put the entries into the first block.
	*/
	C.blocks[1].data.vec[1] = 0.0;


	/*
	* Setup the second block.
	*/

	C.blocks[2].blockcategory = MATRIX;
	C.blocks[2].blocksize = 2 + 1;
	C.blocks[2].data.mat = (double *)malloc((2 + 1) * (2 + 1) * sizeof(double));
	if (C.blocks[2].data.mat == NULL)
	{
		printf("Couldn't allocate storage for C!\n");
		exit(1);
	};

	/*
	* Put the entries into the second block.
	*/

	for (int i = 1; i <= 2 + 1; i++){
		for (int j = 1; j <= 2 + 1; j++){
			C.blocks[2].data.mat[ijtok(i, j, (2 + 1))] = 0.0;
		}
	}

	b = (double *)malloc((6 + 1)*sizeof(double));
	if (b == NULL)
	{
		printf("Failed to allocate storage for a!\n");
		exit(1);
	};


	for (int i = 1; i <= 6; i++){
		b[i] = 0.0;
	}

	constraints = (struct constraintmatrix *)malloc((6 + 1)*sizeof(struct constraintmatrix));
	if (constraints == NULL)
	{
		printf("Failed to allocate storage for constraints!\n");
		exit(1);
	};

	/*
	* Setup the A1 matrix.  Note that we start with block 3 of A1 and then
	* do block 1 of A1.  We do this in this order because the blocks will
	* be inserted into the linked list of A1 blocks in reverse order.
	*/

	/*
	* Terminate the linked list with a NULL pointer.
	*/

	int thisconsnum = 1;

	for (int i = 1; i <= 3; i++){
		for (int j = i; j <= 3; j++){
			constraints[thisconsnum].blocks = NULL;

			blockptr = (struct sparseblock *)malloc(sizeof(struct sparseblock));
			if (blockptr == NULL)
			{
				printf("Allocation of constraint block failed!\n");
				exit(1);
			};

			/*
			* Initialize the coefficients of M
			*/

			blockptr->blocknum = 2;
			blockptr->blocksize = 2 + 1;
			blockptr->constraintnum = thisconsnum;
			blockptr->next = NULL;
			blockptr->nextbyblock = NULL;

			blockptr->entries = (double *)malloc((1 + 1)*sizeof(double));
			if (blockptr->entries == NULL)
			{
				printf("Allocation of constraint block failed!\n");
				exit(1);
			};
			blockptr->iindices = (unsigned short *)malloc((1 + 1)*sizeof(unsigned short));
			if (blockptr->iindices == NULL)
			{
				printf("Allocation of constraint block failed!\n");
				exit(1);
			};
			blockptr->jindices = (unsigned short *)malloc((1 + 1)*sizeof(unsigned short));
			if (blockptr->jindices == NULL)
			{
				printf("Allocation of constraint block failed!\n");
				exit(1);
			};

			blockptr->numentries = 1;

			blockptr->iindices[1] = i;
			blockptr->jindices[1] = j;
			blockptr->entries[1] = 1;

			blockptr->next = constraints[thisconsnum].blocks;
			constraints[thisconsnum].blocks = blockptr;

			/*
			now, we handle the coefficient of lamda
			*/

			blockptr = (struct sparseblock *)malloc(sizeof(struct sparseblock));
			if (blockptr == NULL)
			{
				printf("Allocation of constraint block failed!\n");
				exit(1);
			};

			/*
			* Initialize block 1.
			*/

			blockptr->blocknum = 1;
			blockptr->blocksize = 1;
			blockptr->constraintnum = thisconsnum;
			blockptr->next = NULL;
			blockptr->nextbyblock = NULL;
			blockptr->entries = (double *)malloc((1 + 1)*sizeof(double));
			if (blockptr->entries == NULL)
			{
				printf("Allocation of constraint block failed!\n");
				exit(1);
			};
			blockptr->iindices = (unsigned short *)malloc((1 + 1)*sizeof(unsigned short));
			if (blockptr->iindices == NULL)
			{
				printf("Allocation of constraint block failed!\n");
				exit(1);
			};
			blockptr->jindices = (unsigned short *)malloc((1 + 1)*sizeof(unsigned short));
			if (blockptr->jindices == NULL)
			{
				printf("Allocation of constraint block failed!\n");
				exit(1);
			};

			blockptr->numentries = 1;

			blockptr->iindices[1] = 1;
			blockptr->jindices[1] = 1;
			blockptr->entries[1] = a[i][j];


			blockptr->next = constraints[thisconsnum].blocks;
			constraints[thisconsnum].blocks = blockptr;

			thisconsnum++;

		}
	}


	write_prob("prob.dat-s", 6 + 1 + 2, 6, C, b, constraints);

	initsoln(allsize + 1 + varsize, conssize, C, b, constraints, X, &y, &Z);

	ret = easy_sdp(allsize + 1 + varsize, conssize, C, b, constraints, 0.0, X, &y, &Z, &pobj, &dobj);

	int that_is_a_trick = write_sol("prob.sol", allsize + 1 + varsize, conssize, *X, y, Z);

	/*
	* Free storage allocated for the problem and return.
	*/

	free_prob(allsize + 1 + varsize, conssize, C, b, constraints, *X, y, Z);
	if (that_is_a_trick != 1){
		ret = 100;
	}

	return ret;
}