#include <stdio.h>
#include "printSystem.h"


int printSystem(Node * ptr)
{
	if (ptr == NULL){
		return 1;
	}
	if (EXAMINEWHENPRINT){
		if (examineSystemBeforePrint(ptr)){
			return 1;
		}
	}
	printf("\nĳϵͳ:\n");

	for (int i = 0; i < ptr->a[0]; i++){
		if (ptr->a[i + 1] > 0){
			for (int j = 0, k = 0; j < ptr->a[i + 1]; j++){
				if (k == 1 && ptr->c[i][j] > 0)
					printf(" +");
				else
					printf(" ");
				k = 1;
				if (ptr->b[i][2 * j] == ptr->b[i][2 * j + 1]){
					if (ptr->b[i][2 * j] == 0){
						printf("%.6lf", ptr->c[i][j]);
					}
					else{
						printf("%.6lf*%s^2", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);

					}
				}
				else{
					if (ptr->b[i][2 * j] == 0){
						printf("%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j + 1] - 1]);
					}
					else if (ptr->b[i][2 * j + 1] == 0){
						printf("%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);
					}
					else{
						printf("%.6lf*%s*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1], varnamelist[ptr->b[i][2 * j + 1] - 1]);
					}
				}
			}
			printf(">=0");
		}
		else{
			for (int j = 0, k = 0; j < -ptr->a[i + 1]; j++){
				if (k == 1 && ptr->c[i][j] > 0)
					printf(" +");
				else
					printf(" ");
				k = 1;
				if (ptr->b[i][2 * j] == ptr->b[i][2 * j + 1]){
					if (ptr->b[i][2 * j] == 0){
						printf("%.6lf", ptr->c[i][j]);
					}
					else
						printf("%.6lf*%s^2", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);
				}
				else{
					if (ptr->b[i][2 * j] == 0){
						printf("%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j + 1] - 1]);
					}
					else if (ptr->b[i][2 * j + 1] == 0){
						printf("%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);
					}
					else{
						printf("%.6lf*%s*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1], varnamelist[ptr->b[i][2 * j + 1] - 1]);
					}
				}
			}
			printf(">0");
		}
		printf("\n\n");
	}

	return 0;
}


int printLinearSystem(Node * ptr, int varsize)
{
	if (ptr == NULL){
		return 1;
	}
	for (int i = 0; i < ptr->a[0]; i++){
		for (int j = 0; j <= varsize; j++){
			if (ptr->b[2 * i][j] != 0){
				if (j == 0){
					printf("%d/%d", ptr->b[2 * i][j], ptr->b[2 * i + 1][j]);
				}
				else{
					printf("%d/%d*%s", ptr->b[2 * i][j], ptr->b[2 * i + 1][j], varnamelist[j - 1]);
				}
				printf(" + ");
			}
		}
		printf("\n");
	}
	printf("\n");
	return 0;
}

int printEntailFormula(Node * ptr)
{
	if (ptr == NULL){
		return 1;
	}

	printf("̺ʽں%sһ%dԪ\n", funcnamelist[ptr->a[8]], ptr->a[5]);
	printf("̺ǰ\n");
	for (int pp = 0; pp < ptr->a[5]; pp++){
		for (int i = 0; i <= ptr->a[4]; i++){
			if (ptr->b[2 * pp][i] != 0){
				if (i == 0){
					printf("%d/%d", ptr->b[2 * pp][i], ptr->b[2 * pp + 1][i]);
				}
				else{
					printf("%d/%d*%s", ptr->b[2 * pp][i], ptr->b[2 * pp + 1][i], varnamelist[i - 1]);
				}
				printf(" + ");
			}
		}
		printf(" == 0\n");
	}
	printf("-->\n̺\n");
	printf("%s (%sԪ) == %s (%sԪ)\n", varnamelist[ptr->a[0] - 1], (ptr->a[3] == 1) ? "phi" : ((ptr->a[3] == -1) ? "psi" : "common"), varnamelist[ptr->a[1] - 1], (ptr->a[2] == 1) ? "phi" : ((ptr->a[2] == -1) ? "psi" : "common"));
	printf("±ֱռ˺%sĵ%d͵%d\n\n\n", funcnamelist[ptr->a[8]], ptr->a[7], ptr->a[6]);
	//printf("%d", ptr->a[0]);
	//printf("%d", ptr->a[1]);
	//printf("%d", ptr->a[2]);
	//printf("%d", ptr->a[3]);
	//printf("%d", ptr->a[4]);
	//printf("%d", ptr->a[5]);
	//printf("%d", ptr->a[6]);
	//printf("%d", ptr->a[7]);
	//printf("%d", ptr->a[8]);

	if (ptr->next) {
		printEntailFormula(ptr->next);
	}

	return 0;
}

int printSquareSystem(Node * ptr, int varsize)
{
	if (ptr == NULL){
		return 1;
	}
	printf("%d/%d * (", ptr->b[0][0], ptr->b[1][0]);
	for (int j = 1; j <= varsize + 1; j++){
		if (ptr->b[0][j] != 0){
			if (j == 1){
				printf("%d/%d", ptr->b[0][j], ptr->b[ 1][j]);
			}
			else{
				printf("%d/%d*%s", ptr->b[0][j], ptr->b[1][j], varnamelist[j - 2]);
			}
			printf(" + ");
		}
	}
	printf(")\n");
	return 0;
}

void myprint(Node * ptr) //дʹü
{
	if (ptr->next == NULL){
		int flag = 1;
		Node * temp = ptr;

		//outerTrueValue = 0;//undefined
		while (temp != NULL){

			ptr = temp;
			while (ptr != NULL){

				if (ptr->conj != NULL){
					flag = -1;
					printf("(");
				}

				for (int i = 0; i < ptr->a[0]; i++){
					printf("(");
					if (ptr->a[i + 1] > 0){
						for (int j = 0, k = 0; j < ptr->a[i + 1]; j++){
							if (k == 1 && ptr->c[i][j] > 0)
								printf(" +");
							else
								printf(" ");
							k = 1;
							if (ptr->b[i][2 * j] == ptr->b[i][2 * j + 1]){
								if (ptr->b[i][2 * j] == 0){
									printf("%.6lf", ptr->c[i][j]);
								}
								else{
									printf("%.6lf*%s^2", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);

								}
							}
							else{
								if (ptr->b[i][2 * j] == 0){
									printf("%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j + 1] - 1]);
								}
								else if (ptr->b[i][2 * j + 1] == 0){
									printf("%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);
								}
								else{
									printf("%.6lf*%s*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1], varnamelist[ptr->b[i][2 * j + 1] - 1]);
								}
							}
						}
						printf(">=0");
					}
					else{
						for (int j = 0, k = 0; j < -ptr->a[i + 1]; j++){
							if (k == 1 && ptr->c[i][j] > 0)
								printf(" +");
							else
								printf(" ");
							k = 1;
							if (ptr->b[i][2 * j] == ptr->b[i][2 * j + 1]){
								if (ptr->b[i][2 * j] == 0){
									printf("%.6lf", ptr->c[i][j]);
								}
								else
									printf("%.6lf*%s^2", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);
							}
							else{
								if (ptr->b[i][2 * j] == 0){
									printf("%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j + 1] - 1]);
								}
								else if (ptr->b[i][2 * j + 1] == 0){
									printf("%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);
								}
								else{
									printf("%.6lf*%s*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1], varnamelist[ptr->b[i][2 * j + 1] - 1]);
								}
							}
						}
						printf(">0");
					}
					if (i == ptr->a[0] - 1){
						printf(")");
					}
					else{
						printf(")/\\");
					}
				}
				ptr = ptr->conj;
				if (ptr != NULL){
					printf("/\\");
				}
			}
			temp = temp->with;
			if (flag == -1){
				printf(")");
				flag = 1;
			}
			if (temp != NULL){
				printf("\\/");
			}
		}
		return;
	}

	//֮Ƿβ˵ɨһ飬
	int ert;
	if (ptr->a[1] > 0){
		ert = ptr->a[1];
	}
	else{
		ert = -ptr->a[1];
	}
	if (ert == 1 && ptr->b[0][0] == 0 && 0 == ptr->b[0][1] && ptr->c[0][0] == 0.0){

	}
	else{

		printf("(");
		for (int j = 0, k = 0; j < ert; j++){
			if (k == 1 && ptr->c[0][j] > 0)
				printf(" +");
			else
				printf(" ");
			k = 1;
			if (ptr->b[0][2 * j] == ptr->b[0][2 * j + 1]){
				if (ptr->b[0][2 * j] == 0)
					printf("%.6lf", ptr->c[0][j]);
				else
					printf("%.6lf*%s^2", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1]);
			}
			else{
				if (ptr->b[0][2 * j] == 0){
					printf("%.6lf*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j + 1] - 1]);
				}
				else if (ptr->b[0][2 * j + 1] == 0){
					printf("%.6lf*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1]);
				}
				else{
					printf("%.6lf*%s*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1], varnamelist[ptr->b[0][2 * j + 1] - 1]);
				}
			}
		}
		printf(">0)\\/((");

		for (int j = 0, k = 0; j < ert; j++){
			if (k == 1 && ptr->c[0][j] > 0)
				printf(" +");
			else
				printf(" ");
			k = 1;
			if (ptr->b[0][2 * j] == ptr->b[0][2 * j + 1]){
				if (ptr->b[0][2 * j] == 0)
					printf("%.6lf", ptr->c[0][j]);
				else
					printf("%.6lf*%s^2", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1]);
			}
			else{
				if (ptr->b[0][2 * j] == 0){
					printf("%.6lf*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j + 1] - 1]);
				}
				else if (ptr->b[0][2 * j + 1] == 0){
					printf("%.6lf*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1]);
				}
				else{
					printf("%.6lf*%s*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1], varnamelist[ptr->b[0][2 * j + 1] - 1]);
				}
			}
		}
		printf("=0)/\\(");//=0)/\\[
	}
	myprint2(ptr->next);
	if (ert == 1 && ptr->b[0][0] == 0 && 0 == ptr->b[0][1] && ptr->c[0][0] == 0.0){

	}
	else{
		printf("))");//])
	}

}