#include "simplex_in_Q.h"

int simp_method(int ** A1_up, int ** A1_down, int *b1_up, int *b1_down, int** x, int m, int n)
{
	int ** A_up = (int **)malloc(sizeof(int *)*(m+1));
	int ** A_down = (int **)malloc(sizeof(int *)*(m + 1));
	for (int i = 0; i < m; i++){
		A_up[i] = (int *)malloc(sizeof(int)* (n + 1));
		for (int j = 0; j < n; j++){
			A_up[i][j] = A1_up[i][j];
		}
		A_down[i] = (int *)malloc(sizeof(int)* (n + 1));
		for (int j = 0; j < n; j++){
			A_down[i][j] = A1_down[i][j];
		}
	}
	int * b_up = (int *)malloc(sizeof(int)*(m + 1));
	int * b_down = (int *)malloc(sizeof(int)*(m+1));
	for (int i = 0; i < m; i++){
		b_up[i] = b1_up[i];
		b_down[i] = b1_down[i];
	}


	int * c_up = (int *)malloc(sizeof(int)*(n + m + 1));
	int * c_down = (int *)malloc(sizeof(int)*(n + m + 1));
	for (int i = 0; i < n + 1; i++){
		c_up[i] = 0;
		c_down[i] = 1;
	}
	for (int i = n + 1; i < n + m; i++){
		c_up[i] = 1;
		c_down[i] = 1;
	}

	for (int i = 0; i < m; i++){
		if (b_up[i] < 0){
			for (int j = 0; j < n; j++){
				A_up[i][j] = -A_up[i][j];
			}
			b_up[i] = -b_up[i];
		}
	}
	for (int i = 0; i < m; i++){
		A_up[i] = (int *)realloc(A_up[i], sizeof(int)*(n + m + 1));
		A_down[i] = (int *)realloc(A_down[i], sizeof(int)*(n + m + 1));
	}
	for (int i = 0; i < m; i++){
		for (int j = n; j < n + m; j++){
			if (j == i + n){
				A_up[i][j] = 1;
				A_down[i][j] = 1;
			}
			else{
				A_up[i][j] = 0;
				A_down[i][j] = 1;
			}
		}
	}


	int ret = simplex_method_in_q(c_up, c_down, A_up, A_down, b_up, b_down, x, m, n + m);

	//free
	

	if (ret == 0){
		for (int i = n; i < n + m; i++){
			if (x[0][i] != 0){
				return 1;
			}
		}
		return 0;
	}
	else{
		return 1;
	}
}


int simplex_method_in_q(int *c_up, int *c_down, int ** A_up, int ** A_down, int *b_up, int *b_down, int** x, int m, int n)
{
	int *sigma_up = (int *)malloc(sizeof(int)*(n+1));
	int *sigma_down = (int *)malloc(sizeof(int)*(n+1));
	for (int i = 0; i < n; i++){
		sigma_up[i] = 0;
		sigma_down[i] = 1;
	}

	int *qresult = (int *)malloc(sizeof(int)* 3);

	for (int j = 0; j < n - m; j++){
		for (int i = 1; i < m; i++){
			qresult = fraction_add(sigma_up[j], sigma_down[j], -A_up[i][j], A_down[i][j]);
			sigma_up[j] = qresult[0];
			sigma_down[j] = qresult[1];
			free(qresult);
		}
	}
	//printf("\n\nA:\n");
	//for (int i = 0; i < m; i++){
	//	printf("\n%dУ%dУ\n",i,m);
	//	for (int j = 0; j < n; j++){
	//		if (A_up[i][j]>=0){
	//			printf(" %d/%d  ", A_up[i][j], A_down[i][j]);
	//		}
	//		else{
	//			printf("%d/%d  ", A_up[i][j], A_down[i][j]);
	//		}
	//	}
	//	printf("  %d/%d", b_up[i], b_down[i]);
	//	printf("\n");
	//}
	//printf("\n\nsigma:\n");
	//for (int i = 0; i < n; i++){
	//	if (sigma_up[i]>0){
	//		printf(" %d/%d  ", sigma_up[i], sigma_down[i]);
	//	}
	//	else{
	//		printf("%d/%d  ", sigma_up[i], sigma_down[i]);
	//	}
	//}


	int * theta_up = (int *)malloc(sizeof(int)* (m+1));
	int * theta_down = (int *)malloc(sizeof(int)* (m+1));
	int * thetalist = (int *)malloc(sizeof(int)* (m+1));
	for (int i = 0; i < m; i++){
		theta_up[i] = 0;
		theta_down[i] = 0;
		thetalist[i] = 0;
	}

	int* base = (int *)malloc(sizeof(int)*(m+1));
	for (int j = 0; j < m; j++){
		base[j] = n - m + j;
	}

	bool success_solved = true;
	int tempg;

	while (1){
		int arg_sigma_min = 0;
		for (int i = 1; i < n; i++){
			if (sigma_up[arg_sigma_min] * sigma_down[i] > sigma_down[arg_sigma_min] * sigma_up[i]){
				arg_sigma_min = i;
			}
		}
		if (sigma_up[arg_sigma_min] >= 0){
			success_solved = true;
			break;
		}

		for (int i = 0; i < m; i++){
			thetalist[i] = 0;
		}

		bool no_Aik_positive = true;
		for (int i = 0; i < m; i++){
			if (A_up[i][arg_sigma_min] > 0){
				no_Aik_positive = false;
				thetalist[i] = 1;
				theta_up[i] = b_up[i] * A_down[i][arg_sigma_min];
				theta_down[i] = b_down[i] * A_up[i][arg_sigma_min];
				int g = gcd(theta_up[i], theta_down[i]);
				theta_up[i] = theta_up[i] / g;
				theta_down[i] = theta_down[i] / g;
			}
		}
		if (no_Aik_positive){
			success_solved = false;
			break;
		}

		int arg_theta_min = -1;
		for (int i = 0; i < m; i++){
			if (thetalist[i] == 1){
				if (arg_theta_min == -1){
					arg_theta_min = i;
				}
				else{
					if (theta_up[i] * theta_down[arg_theta_min] < theta_down[i] * theta_up[arg_theta_min]){
						arg_theta_min = i;
					}
				}
			}
		}

		base[arg_theta_min] = arg_sigma_min;

		qresult = (int *)malloc(sizeof(int)* 3);

		for (int j = 0; j < arg_sigma_min; j++){
			qresult[0] = A_up[arg_theta_min][j] * A_down[arg_theta_min][arg_sigma_min];
			qresult[1] = A_down[arg_theta_min][j] * A_up[arg_theta_min][arg_sigma_min];
			int g = gcd(qresult[0], qresult[1]);
			A_up[arg_theta_min][j] = qresult[0];
			A_down[arg_theta_min][j] = qresult[1];
		}
		for (int j = arg_sigma_min + 1; j < n; j++){
			qresult[0] = A_up[arg_theta_min][j] * A_down[arg_theta_min][arg_sigma_min];
			qresult[1] = A_down[arg_theta_min][j] * A_up[arg_theta_min][arg_sigma_min];
			int g = gcd(qresult[0], qresult[1]);
			A_up[arg_theta_min][j] = qresult[0];
			A_down[arg_theta_min][j] = qresult[1];
		}
		qresult[0] = b_up[arg_theta_min] * A_down[arg_theta_min][arg_sigma_min];
		qresult[1] = b_down[arg_theta_min] * A_up[arg_theta_min][arg_sigma_min];
		tempg = gcd(qresult[0], qresult[1]);
		b_up[arg_theta_min] = qresult[0] / tempg;
		b_down[arg_theta_min] = qresult[1] / tempg;

		A_up[arg_theta_min][arg_sigma_min] = 1;
		A_down[arg_theta_min][arg_sigma_min] = 1;

		for (int i = 0; i < m; i++){
			if (i == arg_theta_min)
				continue;
			for (int j = 0; j < n; j++){
				if (j == arg_sigma_min)
					continue;
				qresult[0] = A_up[arg_theta_min][j] * A_up[i][arg_sigma_min];
				qresult[1] = A_down[arg_theta_min][j] * A_down[i][arg_sigma_min];
				int g1 = gcd(qresult[0], qresult[1]);
				qresult[0] = qresult[0] / g1;
				qresult[1] = qresult[1] / g1;
				qresult = fraction_add(A_up[i][j], A_down[i][j], -qresult[0], qresult[1]);
				A_up[i][j] = qresult[0];
				A_down[i][j] = qresult[1];
			}
			qresult[0] = b_up[arg_theta_min] * A_up[i][arg_sigma_min];
			qresult[1] = b_down[arg_theta_min] * A_down[i][arg_sigma_min];
			int g = gcd(qresult[0], qresult[1]);
			qresult[0] = qresult[0] / g;
			qresult[1] = qresult[1] / g;
			qresult = fraction_add(b_up[i], b_down[i], -qresult[0], qresult[1]);
			b_up[i] = qresult[0];
			b_down[i] = qresult[1];

			A_up[i][arg_sigma_min] = 0;
			A_down[i][arg_sigma_min] = 1;
		}

		for (int j = 0; j < n; j++){
			if (j == arg_sigma_min)
				continue;
			qresult[0] = A_up[arg_theta_min][j] * sigma_up[arg_sigma_min];
			qresult[1] = A_down[arg_theta_min][j] * sigma_down[arg_sigma_min];
			int g = gcd(qresult[0], qresult[1]);
			qresult[0] = qresult[0] / g;
			qresult[1] = qresult[1] / g;
			qresult = fraction_add(sigma_up[j], sigma_down[j], -qresult[0], qresult[1]);
			sigma_up[j] = qresult[0];
			sigma_down[j] = qresult[1];
		}
		sigma_up[arg_sigma_min] = 0;
		sigma_down[arg_sigma_min] = 1;

		//printf("\n\nA:\n");
		//for (int i = 0; i < m; i++){
		//	for (int j = 0; j < n; j++){
		//		if (A_up[i][j]>=0){
		//			printf(" %d/%d  ", A_up[i][j], A_down[i][j]);
		//		}
		//		else{
		//			printf("%d/%d  ", A_up[i][j], A_down[i][j]);
		//		}
		//	}
		//	printf("  %d/%d", b_up[i], b_down[i]);
		//	printf("\n");
		//}
		//printf("\n\nsigma:\n");
		//for (int i = 0; i < n; i++){
		//	if (sigma_up[i]>0){
		//		printf(" %d/%d  ", sigma_up[i], sigma_down[i]);
		//	}
		//	else{
		//		printf("%d/%d  ", sigma_up[i], sigma_down[i]);
		//	}
		//}

	}

	if (success_solved){
		for (int j = 0; j < n; j++){
			x[0][j] = 0;
			x[1][j] = 1;
		}
		for (int i = 0; i < m; i++){
			x[0][base[i]] = b_up[i];
			x[1][base[i]] = b_down[i];
		}
		//printf("\n\nx:\n");
		//for (int i = 0; i < n; i++){
		//	if (x[0][i]>=0){
		//		printf(" %d/%d  ", x[0][i], x[1][i]);
		//	}
		//	else{
		//		printf("%d/%d  ", x[0][i], x[1][i]);
		//	}
		//}
		return 0;
	}
	else{
		return 1;
	}
}