#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include "usesdp.h"
#include "declarations.h"

int myusesdp(int f1size, int f2size, int mem_up_bound_ci, int varsize,
	int ** myconstraintsindex, int * myconstraints, double * myconstraintsvalue, struct blockmatrix * X) {


	int fsize = f1size + f2size;
	int allsize = fsize;
	int conssize = mem_up_bound_ci;


	struct blockmatrix C;
	double *b;
	struct constraintmatrix *constraints;

	struct blockmatrix Z;
	double *y;
	double pobj, dobj;

	struct sparseblock *blockptr;

	int ret;

	C.nblocks = 2;
	C.blocks = (struct blockrec *)malloc(3 * sizeof(struct blockrec));
	if (C.blocks == NULL)
	{
		printf("Couldn't allocate storage for C!\n");
		exit(1);
	}

	C.blocks[1].blockcategory = DIAG;
	C.blocks[1].blocksize = allsize;
	C.blocks[1].data.vec = (double *)malloc((allsize + 2)* sizeof(double));
	if (C.blocks[1].data.vec == NULL)
	{
		printf("Couldn't allocate storage for C!\n");
		exit(1);
	};

	/*
	* Put the entries into the first block.
	*/
	//srand((unsigned)time(NULL));
	for (int i = 0; i <= allsize + 1; i++){
		C.blocks[1].data.vec[i] = 0.0;
	}


	/*
	* Setup the second block.
	*/

	C.blocks[2].blockcategory = MATRIX;
	C.blocks[2].blocksize = varsize + 1;
	C.blocks[2].data.mat = (double *)malloc((varsize + 2) * (varsize + 2) * sizeof(double));
	if (C.blocks[2].data.mat == NULL)
	{
		printf("Couldn't allocate storage for C!\n");
		exit(1);
	}
		for (int i = 0; i < (varsize + 2) * (varsize + 2)-1; i++){
			C.blocks[2].data.mat[i] = 0.0;
		}

	/*
	* Put the entries into the second block.
	*/

	for (int i = 1; i <= varsize + 1; i++){
		srand((unsigned)time(NULL));
		for (int j = 1; j <= varsize + 1; j++){
			C.blocks[2].data.mat[ijtok(i, j, (varsize + 1))] = 0.0;
		}
	}

	b = (double *)malloc((conssize + 2)*sizeof(double));
	if (b == NULL)
	{
		printf("Failed to allocate storage for a!\n");
		exit(1);
	};


	for (int i = 0; i <= conssize; i++){
		b[i] = 0.0;
	}
	b[conssize + 1] = 1.0;
	
	constraints = (struct constraintmatrix *)malloc((conssize + 3)*sizeof(struct constraintmatrix));
	if (constraints == NULL)
	{
		printf("Failed to allocate storage for constraints!\n");
		exit(1);
	}
	for (int i = 0; i < conssize + 3; i++){
		constraints[i].blocks = NULL;
	}

	/*
	* Setup the A1 matrix.  Note that we start with block 3 of A1 and then
	* do block 1 of A1.  We do this in this order because the blocks will
	* be inserted into the linked list of A1 blocks in reverse order.
	*/

	/*
	* Terminate the linked list with a NULL pointer.
	*/

	for (int i = 1; i <= conssize; i++){

		constraints[i].blocks = NULL;

		blockptr = (struct sparseblock *)malloc(sizeof(struct sparseblock));
		if (blockptr == NULL)
		{
			printf("Allocation of constraint block failed!\n");
			exit(1);
		};

		/*
		ȳʼڶMֻܶԳƵĳʼԷǶԽϵԪرΣҪ0.5Ϊϵ
		*/

		blockptr->blocknum = 2;
		blockptr->blocksize = varsize + 1;
		blockptr->constraintnum = i;
		blockptr->next = NULL;
		blockptr->nextbyblock = NULL;

		int blocksize = 1;

		blockptr->entries = (double *)malloc((blocksize + 3)*sizeof(double));
		if (blockptr->entries == NULL)
		{
			printf("Allocation of constraint block failed!\n");
			exit(1);
		}
		else{
			for (int j = 0; j < blocksize + 2; j++){
				blockptr->entries[j] = 0.0;
			}
		}
		blockptr->iindices = (unsigned short *)malloc((blocksize + 3)*sizeof(unsigned short));
		if (blockptr->iindices == NULL)
		{
			printf("Allocation of constraint block failed!\n");
			exit(1);
		}
		else{
			for (int j = 0; j < blocksize + 2; j++){
				blockptr->iindices[j] = (unsigned short)0;
			}
		}
		blockptr->jindices = (unsigned short *)malloc((blocksize + 3)*sizeof(unsigned short));
		if (blockptr->jindices == NULL)
		{
			printf("Allocation of constraint block failed!\n");
			exit(1);
		}
		else{
			for (int j = 0; j < blocksize + 2; j++){
				blockptr->jindices[j] = (unsigned short)0;
			}
		}

		blockptr->numentries = blocksize;

		blockptr->iindices[1] = (unsigned short)myconstraintsindex[i][0];
		blockptr->jindices[1] = (unsigned short)myconstraintsindex[i][1];
		if (myconstraintsindex[i][0] == myconstraintsindex[i][1])
			blockptr->entries[1] = 1;
		else
			blockptr->entries[1] = 0.5;

		blockptr->next = constraints[i].blocks;
		constraints[i].blocks = blockptr;


		if (myconstraintsindex[i][2] == 0){
			continue;
		}


		/*
		ʼһ飬
		*/

		blockptr = (struct sparseblock *)malloc(sizeof(struct sparseblock));
		if (blockptr == NULL)
		{
			printf("Allocation of constraint block failed!\n");
			exit(1);
		};

		blockptr->blocknum = 1;
		blockptr->blocksize = allsize;
		blockptr->constraintnum = i;
		blockptr->next = NULL;
		blockptr->nextbyblock = NULL;
		blockptr->entries = (double *)malloc((myconstraintsindex[i][2] + 3)*sizeof(double));
		if (blockptr->entries == NULL)
		{
			printf("Allocation of constraint block failed!\n");
			exit(1);
		}
		else{
			for (int j = 0; j < myconstraintsindex[i][2] + 3; j++){
				blockptr->entries[j] = (double)0.0;
			}
		}
		blockptr->iindices = (unsigned short *)malloc((myconstraintsindex[i][2] + 3)*sizeof(unsigned short));
		if (blockptr->iindices == NULL)
		{
			printf("Allocation of constraint block failed!\n");
			exit(1);
		}
		else{
			for (int j = 0; j < myconstraintsindex[i][2] + 3; j++){
				blockptr->iindices[j] = (unsigned short)0;
			}
		}
		blockptr->jindices = (unsigned short *)malloc((myconstraintsindex[i][2] + 3)*sizeof(unsigned short));
		if (blockptr->jindices == NULL)
		{
			printf("Allocation of constraint block failed!\n");
			exit(1);
		}
		else{
			for (int j = 0; j < myconstraintsindex[i][2] + 3; j++){
				blockptr->jindices[j] = (unsigned short)0;
			}
		}


		blockptr->numentries = myconstraintsindex[i][2];
		for (int iter = 1; iter <= myconstraintsindex[i][2]; iter++){
			blockptr->iindices[iter] = (unsigned short)myconstraints[myconstraintsindex[i][iter + 2]];
			blockptr->jindices[iter] = (unsigned short)myconstraints[myconstraintsindex[i][iter + 2]];
			//if (myconstraintsindex[i][0] == myconstraintsindex[i][1])
			blockptr->entries[iter] = myconstraintsvalue[myconstraintsindex[i][iter + 2]];
		}

		blockptr->next = constraints[i].blocks;
		constraints[i].blocks = blockptr;

	}
	/*start*/

	constraints[conssize + 1].blocks = NULL;

	blockptr = (struct sparseblock *)malloc(sizeof(struct sparseblock));
	if (blockptr == NULL)
	{
		printf("Allocation of constraint block failed!\n");
		exit(1);
	};

	/*
	* Initialize block 1.
	*/

	blockptr->blocknum = 1;
	blockptr->blocksize = allsize;
	blockptr->constraintnum = conssize + 1;
	blockptr->next = NULL;
	blockptr->nextbyblock = NULL;
	blockptr->entries = (double *)malloc((allsize + 3)*sizeof(double));
	if (blockptr->entries == NULL)
	{
		printf("Allocation of constraint block failed!\n");
		exit(1);
	}
	else{
		for (int i = 0; i < allsize + 3; i++){
			blockptr->entries[i] = (double)0.0;
		}
	}
	blockptr->iindices = (unsigned short *)malloc((allsize + 3)*sizeof(unsigned short));
	if (blockptr->iindices == NULL)
	{
		printf("Allocation of constraint block failed!\n");
		exit(1);
	}
	else{
		for (int i = 0; i < allsize + 3; i++){
			blockptr->iindices[i] = (unsigned short)0;
		}
	}
	blockptr->jindices = (unsigned short *)malloc((allsize + 3)*sizeof(unsigned short));
	if (blockptr->jindices == NULL)
	{
		printf("Allocation of constraint block failed!\n");
		exit(1);
	}
	else{
		for (int i = 0; i < allsize + 3; i++){
			blockptr->jindices[i] = (unsigned short)0;
		}
	}


	blockptr->numentries = allsize;
	for (int iter = 1; iter <= allsize; iter++){
		blockptr->iindices[iter] = (unsigned short)iter;
		blockptr->jindices[iter] = (unsigned short)iter;
		blockptr->entries[iter] = 1.0;
	}

	blockptr->next = constraints[conssize + 1].blocks;
	constraints[conssize + 1].blocks = blockptr;

	/*end*/

	//for (int i = 0; i < mem_up_bound_ci; i++){
	//	printf("%d %d %d %d\n", myconstraintsindex[i + 1][0] - 1, myconstraintsindex[i + 1][1] - 1, myconstraintsindex[i + 1][2], myconstraintsindex[i + 1][3]);
	//}


	//write_prob("prob.dat-s", allsize + 1 + varsize, conssize + 1, C, b, constraints);

	initsoln(allsize + 1 + varsize, conssize + 1, C, b, constraints, X, &y, &Z);//xin

	ret = easy_sdp_1(allsize + 1 + varsize, conssize + 1, C, b, constraints, 0.0, X, &y, &Z, &pobj, &dobj);

	int that_is_a_trick = write_sol("prob.sol", allsize + 1 + varsize, conssize + 1, *X, y, Z);

	/*
	* Free storage allocated for the problem and return.
	*/

	//free_prob(allsize + 1 + varsize, conssize + 1, C, b, constraints, *X, y, Z);
	if (that_is_a_trick != 1){
		ret = 100;
	}

	return ret;
}

int usesdp(int varsize, int* varlist_phi_f, int* varlist_psi_f, Node * phi_constraints, Node * psi_constraints, struct blockmatrix * X)
{
	//varsizeԭvarsize

	int f1size = 0;
	int f2size = 0;
	int g1size = 0;
	int g2size = 0;

	int save_phi_a0 = phi_constraints->a[0];
	int save_psi_a0 = psi_constraints->a[0];

	/*
	ⲽǹؼı滻fгֵԪرűɴ1varsize_f֮ټӷû
	*/
	int varsize_f = 0;

	int * varlist_f_change = (int *)malloc((varsize + 3)*sizeof(int));
	int * varlist_f_inversechange = (int *)malloc((varsize + 3)*sizeof(int));
	for (int i = 0; i <= varsize + 2; i++){
		varlist_f_change[i] = 0;
		varlist_f_inversechange[i] = 0;
	}

	for (int i = 1; i <= varsize + 1; i++){
		if (varlist_phi_f[i] == 1 || varlist_psi_f[i] == 1){
			varsize_f++;
			varlist_f_change[i] = varsize_f;
			varlist_f_inversechange[varsize_f] = i;
		}
	}
	varsize_f--;

	if (varsize_f <= 0){
		return -1;
	}
	/*
	varlist_f_changeıphi_constraintsе
	*/
	for (int i = 1; i <= phi_constraints->a[0]; i++){
		for (int j = 0; j<phi_constraints->a[i]; j++){
			phi_constraints->b[i - 1][2 * j] = varlist_f_change[phi_constraints->b[i - 1][2 * j] + 1] - 1;
			phi_constraints->b[i - 1][2 * j + 1] = varlist_f_change[phi_constraints->b[i - 1][2 * j + 1] + 1] - 1;
		}
	}

	for (int i = 1; i <= psi_constraints->a[0]; i++){
		for (int j = 0; j<psi_constraints->a[i]; j++){
			psi_constraints->b[i - 1][2 * j] = varlist_f_change[psi_constraints->b[i - 1][2 * j] + 1] - 1;
			psi_constraints->b[i - 1][2 * j + 1] = varlist_f_change[psi_constraints->b[i - 1][2 * j + 1] + 1] - 1;
		}
	}

	for (int i = 1; i <= phi_constraints->a[0]; i++){
		if (phi_constraints->a[i] > 0){
			f1size++;
		}
		else{
			g1size++;
		}
	}

	for (int i = 1; i <= psi_constraints->a[0]; i++){
		if (psi_constraints->a[i] > 0){
			f2size++;
		}
		else{
			g2size++;
		}
	}

	phi_constraints->a[0] = f1size;
	psi_constraints->a[0] = f2size;

	int allsize = phi_constraints->a[0] + psi_constraints->a[0];
	int mem_up_bound_ci = (varsize_f + 1)*(varsize_f + 2) / 2;

	int* myconstraints = (int *)malloc((mem_up_bound_ci *allsize + 1) * sizeof(int));
	double * myconstraintsvalue = (double *)malloc((mem_up_bound_ci * allsize + 1) * sizeof(double));

	int ** myfconstraintsindex = (int **)malloc((mem_up_bound_ci + 2) * sizeof(int*));
	for (int i = 0; i <= mem_up_bound_ci; i++){
		myfconstraintsindex[i] = (int*)malloc((allsize + 4) * sizeof(int));
		myfconstraintsindex[i][2] = 0;
	}

	int temp_i = 1;
	for (int i = 1; i <= varsize_f + 1; i++){
		for (int j = i; j <= varsize_f + 1; j++){
			myfconstraintsindex[temp_i][0] = i;
			myfconstraintsindex[temp_i][1] = j;
			temp_i++;
		}
	}

	int tempconscount = 0; //¼indexµĿ
	int tempcount = 0; //¼constraintsеĿ
	int num_of_cons = 0; //¼ǵڼԼ
	int thisx;
	int thisy;

	thisx = 0; thisy = 0;

	for (int i = 0; i < f1size; i++){

		num_of_cons++;
		for (int j = 0; j < phi_constraints->a[i + 1]; j++){
			thisx = phi_constraints->b[i][2 * j] + 1;
			thisy = phi_constraints->b[i][2 * j + 1] + 1;

			myconstraints[tempcount] = num_of_cons;

			if (thisx == thisy){
				myconstraintsvalue[tempcount] = phi_constraints->c[i][j];
			}
			else{
				myconstraintsvalue[tempcount] = phi_constraints->c[i][j] / 2;
			}

			for (int searchi = 1; searchi <= mem_up_bound_ci; searchi++){
				if (myfconstraintsindex[searchi][0] == thisx && myfconstraintsindex[searchi][1] == thisy){
					myfconstraintsindex[searchi][myfconstraintsindex[searchi][2] + 3] = tempcount;
					myfconstraintsindex[searchi][2]++;
					break;
				}
			}

			tempcount++;

		}
	}

	for (int i = 0; i < f2size; i++){

		num_of_cons++;
		for (int j = 0; j < psi_constraints->a[i + 1]; j++){
			thisx = psi_constraints->b[i][2 * j] + 1;
			thisy = psi_constraints->b[i][2 * j + 1] + 1;

			myconstraints[tempcount] = num_of_cons;

			if (thisx == thisy){
				myconstraintsvalue[tempcount] = psi_constraints->c[i][j];
			}
			else{
				myconstraintsvalue[tempcount] = psi_constraints->c[i][j] / 2;
			}


			for (int searchi = 1; searchi <= mem_up_bound_ci; searchi++){
				if (myfconstraintsindex[searchi][0] == thisx && myfconstraintsindex[searchi][1] == thisy){
					myfconstraintsindex[searchi][myfconstraintsindex[searchi][2] + 3] = tempcount;
					myfconstraintsindex[searchi][2]++;
					break;
				}
			}

			tempcount++;

		}
	}


	struct blockmatrix *X1 = (struct blockmatrix *)malloc(sizeof(struct blockmatrix));


	int ret = myusesdp(f1size, f2size, mem_up_bound_ci, varsize_f,
		myfconstraintsindex, myconstraints, myconstraintsvalue, X1);


	/*
	ȻҪûphi_constraintspsi_constraintsȻıX
	*/
	/*
	varlist_f_inverse_changeıphi_constraintsе
	*/
	for (int i = 1; i <= phi_constraints->a[0]; i++){
		for (int j = 0; j < phi_constraints->a[i]; j++){
			phi_constraints->b[i - 1][2 * j] = varlist_f_inversechange[phi_constraints->b[i - 1][2 * j] + 1] - 1;
			phi_constraints->b[i - 1][2 * j + 1] = varlist_f_inversechange[phi_constraints->b[i - 1][2 * j + 1] + 1] - 1;
		}
	}
	for (int i = 1; i <= psi_constraints->a[0]; i++){
		for (int j = 0; j < psi_constraints->a[i]; j++){
			psi_constraints->b[i - 1][2 * j] = varlist_f_inversechange[psi_constraints->b[i - 1][2 * j] + 1] - 1;
			psi_constraints->b[i - 1][2 * j + 1] = varlist_f_inversechange[psi_constraints->b[i - 1][2 * j + 1] + 1] - 1;
		}
	}
	/*
	XR[x',y',z']нģҪR[x,y,z]ȥ
	*/

	
	X->nblocks = X1->nblocks;
	X->blocks = (struct blockrec *)malloc(4 * sizeof(struct blockrec));
	if (X->blocks == NULL)
	{
		printf("Couldn't allocate storage for X!\n");
		exit(1);
	};

	X->blocks[1].blockcategory = DIAG;
	X->blocks[1].blocksize = X1->blocks[1].blocksize;
	X->blocks[1].data.vec = (double *)malloc((allsize + 2) * sizeof(double));
	if (X->blocks[1].data.vec == NULL)
	{
		printf("Couldn't allocate storage for X!\n");
		exit(1);
	};
	for (int i = 1; i <= allsize; i++){
		X->blocks[1].data.vec[i] = X1->blocks[1].data.vec[i];
	}

	X->blocks[2].blockcategory = MATRIX;
	X->blocks[2].blocksize = X1->blocks[2].blocksize;
	X->blocks[2].data.mat = (double *)malloc((varsize + 2) * (varsize + 1) * sizeof(double));
	if (X->blocks[2].data.mat == NULL)
	{
		printf("Couldn't allocate storage for X!\n");
		exit(1);
	};

	for (int i = 1; i <= varsize + 1; i++){
		for (int j = 1; j <= varsize + 1; j++){
			if (varlist_f_change[i]>0 && varlist_f_change[j] > 0){
				X->blocks[2].data.mat[ijtok(i, j, (varsize + 1))]
					= X1->blocks[2].data.mat[ijtok(varlist_f_change[i], varlist_f_change[j], (varsize_f + 1))];
			}
			else{
				X->blocks[2].data.mat[ijtok(i, j, (varsize + 1))] = 0;
			}
		}
	}

	//for (int blk = 1; blk <= X1->nblocks; blk++)
	//{
	//	switch (X1->blocks[blk].blockcategory)
	//	{
	//	case DIAG:
	//		for (int i = 1; i <= X1->blocks[blk].blocksize; i++)
	//		{
	//			double ent = X1->blocks[blk].data.vec[i];
	//			//fprintf(fid, "2 %d %d %d %.18e \n", blk, i, i, ent);
	//			printf("1 %d %d %d %.8lf \n", blk, i, i, ent);
	//		};
	//		break;
	//	case MATRIX:
	//		for (int i = 1; i <= X1->blocks[blk].blocksize; i++)
	//		for (int j = i; j <= X1->blocks[blk].blocksize; j++)
	//		{
	//			double ent = X1->blocks[blk].data.mat[ijtok(i, j, X1->blocks[blk].blocksize)];
	//			//fprintf(fid, "2 %d %d %d %.18e \n", blk, i, j, ent);
	//			printf("1 %d %d %d %.8lf \n", blk, i, j, ent);
	//		};
	//		break;
	//	case PACKEDMATRIX:
	//	default:
	//		printf("writesol Invalid Block Type!\n");
	//		exit(12);
	//	};
	//};

	//for (int blk = 1; blk <= X->nblocks; blk++)
	//{
	//	switch (X->blocks[blk].blockcategory)
	//	{
	//	case DIAG:
	//		for (int i = 1; i <= X->blocks[blk].blocksize; i++)
	//		{
	//			double ent = X->blocks[blk].data.vec[i];
	//			//fprintf(fid, "2 %d %d %d %.18e \n", blk, i, i, ent);
	//			printf("2 %d %d %d %.8lf \n", blk, i, i, ent);
	//		};
	//		break;
	//	case MATRIX:
	//		for (int i = 1; i <= X->blocks[blk].blocksize; i++)
	//		for (int j = i; j <= X->blocks[blk].blocksize; j++)
	//		{
	//			double ent = X->blocks[blk].data.mat[ijtok(i, j, X->blocks[blk].blocksize)];
	//			//fprintf(fid, "2 %d %d %d %.18e \n", blk, i, j, ent);
	//			printf("2 %d %d %d %.8lf \n", blk, i, j, ent);
	//		};
	//		break;
	//	case PACKEDMATRIX:
	//	default:
	//		printf("writesol Invalid Block Type!\n");
	//		exit(12);
	//	};
	//};

	phi_constraints->a[0] = save_phi_a0;
	psi_constraints->a[0] = save_psi_a0;

	return ret;

}