#include <Windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
/*
 * Include CSDP declarations so that we'll know the calling interfaces.
 */

#include "declarations.h"
#include "input.h"
#include "output.h"
#include "usesdp.h"

//SetErrorMode( SEM_NOGPFAULTERRORBOX |SEM_NOGPFAULTERRORBOX);

void SelfReduce(Node * result)
{
	
}

void FindEqualVar(int numberOfVar, char * receiveChar)
{
	for (int i = 0; i < phi_equal_constraints->a[0]; i++){
		int have = 0;
		for (int j = 0; j < 2 * phi_equal_constraints->a[i + 1]; j++){
			if (phi_equal_constraints->b[i][j] == numberOfVar) {
				have = j / 2 + 1;
				break;
			}
		}
		if (have){
			double c = phi_equal_constraints->c[i][have];
			int index = 0;
			char * temp = malloc(sizeof(char)* 20);
			int firstOne = 1;
			for (int j = 0; j < phi_equal_constraints->a[i + 1]; j++){
				if (j != have){
					if (!firstOne){
						receiveChar[index++] = '+';
						firstOne = 0;
					}
					sprintf(temp, "%.6lf", -phi_equal_constraints->c[i][j] / c);
					for (int k = 0; k < 8; k++){
						receiveChar[index++] = temp[k];
					}
					if (phi_equal_constraints->b[i][2 * j]){
						int num = phi_equal_constraints->b[i][2 * j] - 1;
						receiveChar[index++] = '*';
						strcpy_s(&receiveChar[index], strlen(varnamelist[num]), varnamelist[num]);
						index += strlen(varnamelist[num]);
					}
					if (phi_equal_constraints->b[i][2 * j + 1]){
						int num = phi_equal_constraints->b[i][2 * j] - 1;
						receiveChar[index++] = '*';
						strcpy_s(&receiveChar[index], strlen(varnamelist[num]), varnamelist[num]);
						index += strlen(varnamelist[num]);
					}
				}
			}
			receiveChar[index] = '\0';
			return;
		}
	}
	receiveChar[0] = '\0';
	return;
}

void ChangeAllZeroOne(int numberOfVar, Node * result)
{
	//printf("============================================");
	//Node * temp_ptr = N_phi;
	//printEntailFormula(temp_ptr);
	//while (temp_ptr) {
	//	if (temp_ptr->a[0] == numberOfVar) {
	//		VariableReplacement(phi_equal_constraints, temp_ptr->a[0], temp_ptr->a[1]);
	//	}
	//	else if (temp_ptr->a[1] == numberOfVar) {
	//		VariableReplacement(phi_equal_constraints, temp_ptr->a[1], temp_ptr->a[0]);
	//	}
	//	printf("============================================");
	//	temp_ptr = temp_ptr->next;
	//}
	//printf("============================================");
	//temp_ptr = N_psi;
	//printEntailFormula(temp_ptr);
	//while (temp_ptr) {
	//	if (temp_ptr->a[0] == numberOfVar) {
	//		VariableReplacement(psi_equal_constraints, temp_ptr->a[0], temp_ptr->a[1]);
	//	}
	//	else if (temp_ptr->a[1] == numberOfVar) {
	//		VariableReplacement(psi_equal_constraints, temp_ptr->a[1], temp_ptr->a[0]);
	//	}
	//	printf("============================================");
	//	temp_ptr = temp_ptr->next;
	//}

	//printSystem(phi_equal_constraints);
	//printSystem(psi_equal_constraints);
	int have = 0;
	for (int i = 0; i < phi_equal_constraints->a[0]; i++){
		for (int j = 0; j < 2 * phi_equal_constraints->a[i + 1]; j++){
			if (phi_equal_constraints->b[i][j] == numberOfVar) {
				have = i + 1;
				break;
			}
		}
	}
	
	do{
		if (have){
			int * phi_only_emulate = malloc(sizeof(int)* 2);
			phi_only_emulate[0] = numberOfVar + 1;
			phi_only_emulate[1] = -1;

			Node * eliminateEqual = (Node *)malloc(sizeof(Node));
			eliminateEqual->a = (int *)malloc(sizeof(int)* 2);
			eliminateEqual->a[0] = 1;
			eliminateEqual->a[1] = phi_equal_constraints->a[have];
			eliminateEqual->b = (int **)malloc(sizeof(int *));
			eliminateEqual->b[0] = phi_equal_constraints->b[have - 1];
			eliminateEqual->c = (double **)malloc(sizeof(double *));
			eliminateEqual->c[0] = phi_equal_constraints->c[have - 1];
			//printf("=======================================\n");
			//printf("begin :\n");
			//printSystem(result);
			eliminateLinearConstraintsByEqualForm(varsize, result, eliminateEqual, phi_only_emulate);
			//printf("end :\n");
			//printSystem(result);
			//printf("=======================================\n");
			//printSystem(result->next);
		}
		result = result->next;
	} while (result);

	return;
}

void interp2(const char * myfilename)
{
	//if (!inputType) {
	//	Re_Output_Problem(myfilename);
	//}
	clock_t time_start, time_finish;
	time_start = clock();

	cf_ptr = NULL;

	//char * phipsiOutput = (char *)malloc(sizeof(char)* 2000);
	//int phipsiOutputCapacity = 0;

	original_varsize = 0;

	//int examine_higher = 0;
	//int ** data;

	has_a_euf = 0;
	/*
	ʼ
	*/
	char * foutname = createOutputFileName(myfilename);
	//if (WEB_VERSION){
	//	fp_show = NULL;
	//}
	//else{
	fp_show = fopen(foutname, "w");
	if (fp_show == NULL){
		printf("The file doesn't exist.");
		exit(1);
	}
	//}

	//FILE * fp = NULL;
	//fopen_s(&fp, myfilename, "r+");
	//if (fp == NULL){
	//	printf("The file doesn't exist.");
	//	exit(1);
	//}

	N_phi = NULL;
	N_psi = NULL;
	N_mix = NULL;

	int * qresult = NULL;

	Node * phi_constraints = (Node *)malloc(sizeof(Node));
	Node * psi_constraints = (Node *)malloc(sizeof(Node));

	phi_equal_constraints = (Node *)malloc(sizeof(Node));
	phi_equal_constraints->a = NULL;
	phi_equal_constraints->b = NULL;
	phi_equal_constraints->c = NULL;
	phi_equal_constraints->d = NULL;
	psi_equal_constraints = (Node *)malloc(sizeof(Node));
	psi_equal_constraints->a = NULL;
	psi_equal_constraints->b = NULL;
	psi_equal_constraints->c = NULL;
	psi_equal_constraints->d = NULL;

	phi_equals = (int *)malloc(sizeof(int)* 101);
	for (int i = 0; i <= 100; i++){
		phi_equals[i] = 0;
	}
	psi_equals = (int *)malloc(sizeof(int)* 101);
	for (int i = 0; i <= 100; i++){
		psi_equals[i] = 0;
	}

	varNameList = malloc(sizeof(char *)* 100);
	funcNameList = malloc(sizeof(char *)* 100);
	funcVarRef = malloc(sizeof(int)* 100);
	for (int i = 0; i < 100; i++){
		funcVarRef[i] = 0;
	}

	InputInitial();

	newInputFunction(myfilename, phi_constraints, psi_constraints);


	if (has_a_euf){
		/*ѵʽȥphi_equal_constraints*/
		phi_equal_constraints->a = (int *)malloc(sizeof(int)* (phi_equals[0] + 2));
		phi_equal_constraints->a[0] = phi_equals[0];
		phi_equal_constraints->b = (int **)malloc(sizeof(int *)* (phi_equals[0] + 1));
		phi_equal_constraints->c = (double **)malloc(sizeof(double *)* (phi_equals[0] + 1));
		for (int i = 1, j = 0; i <= phi_constraints->a[0]; i++){
			if (phi_equals[i] == 1){
				phi_equal_constraints->a[j + 1] = phi_constraints->a[i];
				phi_constraints->a[i] = 0;
				phi_equal_constraints->b[j] = phi_constraints->b[i - 1];
				phi_constraints->b[i - 1] = NULL;
				phi_equal_constraints->c[j] = phi_constraints->c[i - 1];
				phi_constraints->c[i - 1] = NULL;
				j++;
			}
		}

		/*ѵʽȥpsi_equal_constraints*/
		psi_equal_constraints->a = (int *)malloc(sizeof(int)* (psi_equals[0] + 2));
		psi_equal_constraints->a[0] = psi_equals[0];
		psi_equal_constraints->b = (int **)malloc(sizeof(int *)* (psi_equals[0] + 1));
		psi_equal_constraints->c = (double **)malloc(sizeof(double *)* (psi_equals[0] + 1));
		for (int i = 1, j = 0; i <= psi_constraints->a[0]; i++){
			if (psi_equals[i] == 1){
				psi_equal_constraints->a[j + 1] = psi_constraints->a[i];
				psi_constraints->a[i] = 0;
				psi_equal_constraints->b[j] = psi_constraints->b[i - 1];
				psi_constraints->b[i - 1] = NULL;
				psi_equal_constraints->c[j] = psi_constraints->c[i - 1];
				psi_constraints->c[i - 1] = NULL;
				j++;
			}
		}
	}
	else{ //ûeufƵʽ
		phi_constraints->a = (int *)realloc(phi_constraints->a, sizeof(int)* (phi_constraints->a[0] + 2 + phi_equals[0]));
		phi_constraints->b = (int **)realloc(phi_constraints->b, sizeof(int *)* (phi_constraints->a[0] + 1 + phi_equals[0]));
		for (int i = 0; i < phi_equals[0]; i++){
		}
		phi_constraints->c = (double **)realloc(phi_constraints->c, sizeof(double *)* (phi_constraints->a[0] + 1 + phi_equals[0]));
		for (int i = 1, j = phi_constraints->a[0]; i <= phi_constraints->a[0]; i++){
			if (phi_equals[i] == 1){
				phi_constraints->a[j + 1] = phi_constraints->a[i];
				phi_constraints->b[j] = (int *)malloc(sizeof(int)*(phi_constraints->a[i] + 1) * 2);
				phi_constraints->c[j] = (double *)malloc(sizeof(double)*(phi_constraints->a[i] + 1));
				for (int k = 0; k < phi_constraints->a[i]; k++){
					phi_constraints->b[j][2 * k] = phi_constraints->b[i - 1][2 * k];
					phi_constraints->b[j][2 * k + 1] = phi_constraints->b[i - 1][2 * k + 1];
					phi_constraints->c[j][k] = -phi_constraints->c[i - 1][k];
				}
				j++;
			}
		}
		phi_constraints->a[0] = phi_constraints->a[0] + phi_equals[0];

		psi_constraints->a = (int *)realloc(psi_constraints->a, sizeof(int)* (psi_constraints->a[0] + 2 + psi_equals[0]));
		psi_constraints->b = (int **)realloc(psi_constraints->b, sizeof(int *)* (psi_constraints->a[0] + 1 + psi_equals[0]));
		psi_constraints->c = (double **)realloc(psi_constraints->c, sizeof(double *)* (psi_constraints->a[0] + 1 + psi_equals[0]));
		for (int i = 1, j = psi_constraints->a[0]; i <= psi_constraints->a[0]; i++){
			if (psi_equals[i] == 1){
				psi_constraints->a[j + 1] = psi_constraints->a[i];
				psi_constraints->b[j] = (int *)malloc(sizeof(int)*(psi_constraints->a[i] + 1) * 2);
				psi_constraints->c[j] = (double *)malloc(sizeof(double)*(psi_constraints->a[i] + 1));
				for (int k = 0; k < psi_constraints->a[i]; k++){
					psi_constraints->b[j][2 * k] = psi_constraints->b[i - 1][2 * k];
					psi_constraints->b[j][2 * k + 1] = psi_constraints->b[i - 1][2 * k + 1];
					psi_constraints->c[j][k] = -psi_constraints->c[i - 1][k];
				}
				j++;
			}
		}
		psi_constraints->a[0] = psi_constraints->a[0] + psi_equals[0];
	}

	//int examine_more = 0;
	//for (int i = 0; i < phi_equal_constraints->a[0]; i++){
	//	for (int j = 0; j < phi_equal_constraints->a[i + 1]; j++){
	//		if (phi_equal_constraints->b[i][2 * j]>0){
	//			examine_more = 1;
	//		}
	//	}
	//}
	//for (int i = 0; i < psi_equal_constraints->a[0]; i++){
	//	for (int j = 0; j < psi_equal_constraints->a[i + 1]; j++){
	//		if (psi_equal_constraints->b[i][2 * j]>0){
	//			examine_more = 1;
	//		}
	//	}
	//}
	//if (examine_more == 1){
	//	solve_higher_problem(myfilename);
	//	exit(0);
	//}



	/* Ĵʹ>=0Ĳʽǰ>0Ĳʽں*/
	for (int i = 1, j = phi_constraints->a[0]; i < j;){
		if (phi_constraints->a[i] <= 0){
			if (phi_constraints->a[j]>0){
				int temp = phi_constraints->a[i];
				phi_constraints->a[i] = phi_constraints->a[j];
				phi_constraints->a[j] = temp;
				int * tempp = phi_constraints->b[i - 1];
				phi_constraints->b[i - 1] = phi_constraints->b[j - 1];
				phi_constraints->b[j - 1] = tempp;
				double *tempp2 = phi_constraints->c[i - 1];
				phi_constraints->c[i - 1] = phi_constraints->c[j - 1];
				phi_constraints->c[j - 1] = tempp2;
				i++; j--;
			}
			else{
				j--;
			}
		}
		else{
			i++;
		}
	}
	for (int i = 1, j = phi_constraints->a[0]; i < j;){
		if (phi_constraints->a[i] == 0){
			if (phi_constraints->a[j] < 0){
				int temp = phi_constraints->a[i];
				phi_constraints->a[i] = phi_constraints->a[j];
				phi_constraints->a[j] = temp;
				int * tempp = phi_constraints->b[i - 1];
				phi_constraints->b[i - 1] = phi_constraints->b[j - 1];
				phi_constraints->b[j - 1] = tempp;
				double *tempp2 = phi_constraints->c[i - 1];
				phi_constraints->c[i - 1] = phi_constraints->c[j - 1];
				phi_constraints->c[j - 1] = tempp2;
				i++; j--;
			}
			else{
				j--;
			}
		}
		else{
			i++;
		}
	}
	if (has_a_euf){
		phi_constraints->a[0] = phi_constraints->a[0] - phi_equals[0];
	}

	for (int i = 1, j = psi_constraints->a[0]; i < j;){
		if (psi_constraints->a[i] <= 0){
			if (psi_constraints->a[j] > 0){
				int temp = psi_constraints->a[i];
				psi_constraints->a[i] = psi_constraints->a[j];
				psi_constraints->a[j] = temp;
				int * tempp = psi_constraints->b[i - 1];
				psi_constraints->b[i - 1] = psi_constraints->b[j - 1];
				psi_constraints->b[j - 1] = tempp;
				double * tempp2 = psi_constraints->c[i - 1];
				psi_constraints->c[i - 1] = psi_constraints->c[j - 1];
				psi_constraints->c[j - 1] = tempp2;
				i++; j--;
			}
			else{
				j--;
			}
		}
		else{
			i++;
		}
	}
	for (int i = 1, j = psi_constraints->a[0]; i < j;){
		if (psi_constraints->a[i] == 0){
			if (psi_constraints->a[j] < 0){
				int temp = psi_constraints->a[i];
				psi_constraints->a[i] = psi_constraints->a[j];
				psi_constraints->a[j] = temp;
				int * tempp = psi_constraints->b[i - 1];
				psi_constraints->b[i - 1] = psi_constraints->b[j - 1];
				psi_constraints->b[j - 1] = tempp;
				double * tempp2 = psi_constraints->c[i - 1];
				psi_constraints->c[i - 1] = psi_constraints->c[j - 1];
				psi_constraints->c[j - 1] = tempp2;
				i++; j--;
			}
			else{
				j--;
			}
		}
		else{
			i++;
		}
	}
	if (has_a_euf){
		psi_constraints->a[0] = psi_constraints->a[0] - psi_equals[0];
	}

	//Node * tmp = N_half[0];
	//while (tmp != NULL){
	//	printf("f   %d   %d   %d\n", tmp->a[0], tmp->a[1], tmp->a[2]);
	//	tmp = tmp->next;
	//}

	//printf(".\n");
	//printf("phi:\n");
	//printSystem(phi_constraints);
	//printf("psi:\n");
	//printSystem(psi_constraints);
	//printf("\n");


	Node * result = ig_cqi2(phi_constraints, psi_constraints);
	printSystem(result);
	time_finish = clock();
	//system("Pause");
	if (result == NULL){
		if (webVersion){
			solve_higher_problem_for_web(myfilename);
			exit(666);
		}
		else{
			printf("%s", phipsiOutput);
			solve_higher_problem(myfilename);
			exit(2);
		}
	}
	printf("%s", phipsiOutput);
	//OutputH_half();
	//varnamelist
	for (int i = 0; i < funcsize; i++){
		Node * tempNode = N_half[i];
		while (tempNode != NULL){
			int numberOfVar = tempNode->a[0] - 1;
			varnamelist[numberOfVar] = realloc(varnamelist[numberOfVar], sizeof(char)* 200);
			sprintf(varnamelist[numberOfVar], "%s(", funcnamelist[i]);
			int ret1 = strlen(funcnamelist[i]) + 1;
			char * receiveChar = (char *)malloc(sizeof(char)* 200);
			int notFirstOne = 0;
			for (int j = 0; j <= varsize; j++){
				if (tempNode->b[0][j] != 0){
					if (tempNode->b[0][j] > 0 && notFirstOne){
						varnamelist[numberOfVar][ret1] = '+';
						ret1++;
					}
					sprintf(receiveChar, "%.6lf", (double)tempNode->b[0][j] / (double)tempNode->b[1][j]);
					for (int k = 0; k < 8; k++){
						varnamelist[numberOfVar][k + ret1] = receiveChar[k];
					}
					ret1 += 8;
					if (j != 0){
						varnamelist[numberOfVar][ret1] = '*';
						ret1++;
					}
					if (j != 0){
						for (int k = 0; k < strlen(varnamelist[j - 1]); k++){
							varnamelist[numberOfVar][k + ret1] = varnamelist[j - 1][k];
						}
						ret1 += strlen(varnamelist[j - 1]);
					}
					notFirstOne = 1;
				}
			}
			if (notFirstOne == 0) {
				// All zero
				ChangeAllZeroOne(numberOfVar + 1, result);
				//strcpy_s(varnamelist[numberOfVar], strlen(receiveChar) + 1, receiveChar);
			}
			varnamelist[numberOfVar][ret1] = ')';
			ret1++;
			varnamelist[numberOfVar][ret1] = '\0';
			tempNode = tempNode->next;
		}
	}
	//Output_varname_list();
	//ͳƹδͺ
	for (int i = 0; i < funcsize; i++){
		if (function_list_phi[i] == 1 && function_list_psi[i] == 1){
			function_list_common[i] = 1;
		}
	}

	for (int i = 0; i < original_varsize; i++){
		if (variable_phi[i] == 1 && variable_psi[i] == 1){
			variable_common[i] = 1;
		}
	}


	printf("\ncommon symbols: [");
	int isFirstOutput = 0;
	for (int i = 0; i < original_varsize; i++){
		if (variable_common[i] == 1){
			if (isFirstOutput){
				printf(" ");
			}
			printf("%s", varnamelist[i]);
			isFirstOutput = 1;
		}
	}
	for (int i = 0; i < funcsize; i++){
		if (function_list_common[i] == 1){
			if (isFirstOutput){
				printf(" ");
			}
			printf("%s", funcnamelist[i]);
			isFirstOutput = 1;
		}
	}
	printf("]\n");
	//for (int i = 0; i < varsize; i++){
	//	printf("%s\n", varnamelist[i]);
	//}

	//system("Pause");
	printf("\n\nInterpolant:\n\n");

	//outerTrueValue = (int *)malloc(sizeof(int)* 100);
	//for (int i = 0; i < 100; i++){
	//	outerTrueValue[i] = -2;
	//}

	//print_examine(result);

	//printf("\n");
	//for (int i = 0; i < 5; i++){
	//	printf("outerTrueValue[%d] = %d\n",i,outerTrueValue[i]);
	//}
	//hasprintsth = 0;


	SelfReduce(result);
	/*
	 redlog
	 */
	char * input = malloc(sizeof(char)* 500);
	int inputtemp = 0;
	FILE * fileForRedlog = fopen("FileForRedlog1.txt", "w+");
	if (fileForRedlog == NULL){

		myprint2(result);
	}
	else{

		fprintf(fileForRedlog, "rlset r$;\n");
		fprintf(fileForRedlog, "off nospilt;\n");
		fprintf(fileForRedlog, "off nat;\n");
		fprintf(fileForRedlog, "on rlsism;\n");
		fprintf(fileForRedlog, "operator ");

		isFirstOutput = 1;
		for (int i = 0; i < funcsize; i++){
			if (function_list_common[i] == 1){
				if (isFirstOutput){
					fprintf(fileForRedlog, " ");
					isFirstOutput = 0;
				}
				else {
					fprintf(fileForRedlog, ", ");
				}
				fprintf(fileForRedlog, "%s", funcnamelist[i]);
			}
		}

		fprintf(fileForRedlog, ";\n");

		fprintf(fileForRedlog, "out temp;\n");
		fprintf(fileForRedlog, "rlsimpl (");


		fshowToFile(fileForRedlog, result);
		fprintf(fileForRedlog, ");\n");

		fprintf(fileForRedlog, "shut temp;\n");

		fclose(fileForRedlog);

		system("reduce.exe FileForRedlog1.txt");

		FILE * fileForRedlog2 = fopen("temp", "r+");
		if (fileForRedlog2 == NULL){
			printf("Not open.\n");
			myprint2(result);
		}
		else{
			inputtemp = 0;
			while (fgetc(fileForRedlog2) != '\n');

			int starFlag = 0;
			while ((input[inputtemp] = fgetc(fileForRedlog2)) != '$'){
				if (input[inputtemp] == '\n'){
					continue;
				}
				if (input[inputtemp] == '*'){
					if (starFlag == 0){
						starFlag = 1;
					}
					else{
						starFlag = 0;
						inputtemp--;
						input[inputtemp] = '^';
					}
				}
				else{
					starFlag = 0;
				}
				if (input[inputtemp] == 'd' && inputtemp >= 3 && input[inputtemp - 1] == 'n' && input[inputtemp - 2] == 'a'){
					inputtemp--;
					input[inputtemp - 1] = '/';
					input[inputtemp] = '\\';
				}
				if (input[inputtemp] == 'r' && inputtemp >= 2 && input[inputtemp - 1] == 'o'){
					input[inputtemp - 1] = '\\';
					input[inputtemp] = '/';
				}
				inputtemp++;
			}
			if (inputtemp >= 0){
				input[inputtemp] = '\0';
				printf("%s", input);
			}
			else{
				myprint2(result);
			}
			fclose(fileForRedlog2);
		}

	}


	/*
	 redlog
	 */

	//myprint2(result);

	//bool ifFinalResultTrue = false;
	//if (hasprintsth == 0){
	//	int outerWithCounter = 0;
	//	while (outerTrueValue[outerWithCounter] != -2){
	//		if (outerTrueValue[outerWithCounter] == 0){
	//			ifFinalResultTrue = true;
	//			hasprintsth = 1;
	//			break;
	//		}
	//		if (outerTrueValue[outerWithCounter] != -1){
	//			hasprintsth = 1;
	//		}
	//		outerTrueValue++;
	//	}
	//	if (hasprintsth == 0){
	//		printf("No interpolant is found.");
	//	}
	//}
	//if (hasprintsth && ifFinalResultTrue){
	//	printf("true");
	//}

	printf("\n\n\n");


	printf("Time: %lf seconds.\n", (double)(time_finish - time_start) / CLOCKS_PER_SEC);

	if (!webVersion){
		printf("\nSee in %s for intermediate results.\n\n", foutname);
	}

	if (fp_show){
		fprintf(fp_show, "\n\n\nInterpolant:\n");
		fshow(result);
	}

	//fclose(fp);

	if (fp_show){
		fclose(fp_show);
	}

	if (webVersion){
		remove(foutname);
	}

	//free
	//free(phi_constraints->a);
	//for (int i = 0; i <; i++){
	//	free(phi_constraints->b[i]);

	//}

}

int main(int argc, char ** argv)
{
	//SetErrorMode(SEM_NOGPFAULTERRORBOX | SEM_NOGPFAULTERRORBOX);
	//HeapSetInformation(NULL, HeapEnableTerminationOnCorruption, NULL, 0);
	//const char * myfilename = { "7.1subproblem1.txt\0" };
	//interp2(myfilename);
	//printf(" ------------------------------------------------------------------------\n");
	//printf("|                                                                        |\n");
	//printf("|       NLFIntp: Synthesizing Interpolants for Nonlinear Formulas        |\n");
	//printf("|                                                                        |\n");
	//printf(" ------------------------------------------------------------------------\n");


	inputType = 0;
	webVersion = 0;
	//WEB_VERSION

	if (argc > 1){

		if (argc >= 3){
			if (argv[2][0] == '1'){
				inputType = 1;
			}
			//printf("inputType = %d\n", inputType);
			webVersion = 1;
		}
		else{
			printf(" ------------------------------------------------------------------------\n");
			printf("|                                                                        |\n");
			printf("|       NLFIntp: Synthesizing Interpolants for Nonlinear Formulas        |\n");
			printf("|                                                                        |\n");
			printf(" ------------------------------------------------------------------------\n");
		}

		if (inputType){
			clock_t time_start, time_finish;

			time_start = clock();
			//parseProblem(argv[1]);

			char useSOS3Filename[80];
			sprintf(useSOS3Filename, "SOS3.exe %s", argv[1]);
			system(useSOS3Filename);

			time_finish = clock();
			printf("\n\nTime: %lf seconds.\n", (double)(time_finish - time_start) / CLOCKS_PER_SEC);
		}
		else{
			interp2(argv[1]);
			///printf("%s", argv[1]);
		}

	}
	else{
		printf(" ------------------------------------------------------------------------\n");
		printf("|                                                                        |\n");
		printf("|       NLFIntp: Synthesizing Interpolants for Nonlinear Formulas        |\n");
		printf("|                                                                        |\n");
		printf(" ------------------------------------------------------------------------\n");
		char * fileinput = (char *)malloc(sizeof(char)* 500);

		printf("\nPlease specify the input file: ");
		scanf("%s", fileinput);
		printf("\n");
		interp2(fileinput);

		system("Pause");


	}

	remove("prob.sol");
	remove("prob.dat-s");
	remove("temp");
	remove("FileForRedlog.txt");


	return 0;
}
