%{
#include <stdio.h>
#include <stdlib.h>
#include "input.h"
struct polySystem_2d* phi_pre;
int phi_or_psi; // 0 for phi, 1 for psi
extern int yylineno;
%}

%union {
 struct polySystem_2d* my_param;
 struct mono *my_mono;
 struct poly_2d *my_poly;
 double number;
 int exponent;
 char * name;
}

/*declare tokens*/
%token<name> NAME
%token<name> TITLE
%token<exponent> UNEXP
%token<number> NUMBER
%token BIG BIGEQUAL
%token SMALL SMALLEQUAL
%token EQUAL
%token EOL
%type<my_poly> exp
%type<my_mono> factor EXPRESULT term
%type<my_param> PARALIST
%type<exponent> polylist

%%

MYLINE:
 | MYLINE EOL polylist { }
 | MYLINE EOL { }
 | polylist { }
 ;

polylist: TITLE {
     phi_pre = newpolySystem_2d($1);
     if (inputSave[0] ){
         if (inputSave[1]) {
             yyerror("There're more than two poly systems.");
         }
         else{
             phi_or_psi = 1;
             inputSave[1] = phi_pre;
         }
     }
     else{
         phi_or_psi = 0;
         inputSave[0] = phi_pre;
     }
                         }
 |  exp BIG NUMBER  {
     if ($3 != 0) { yyerror("The right hand need to be zero.\n"); }
     addPoly(phi_pre, $1, -1, 1);
     free($1);
     /*printPolySystem_2d(phi_pre);*/  }
 |  exp BIGEQUAL NUMBER  {
     if ($3 != 0) { yyerror("The right hand need to be zero.\n"); }
     addPoly(phi_pre, $1, 1, 1);
     free($1);
     /*printPolySystem_2d(phi_pre);*/  }
 |  exp SMALL NUMBER  {
     if ($3 != 0) { yyerror("The right hand need to be zero.\n"); }
     addPoly(phi_pre, $1, -1, -1);
     free($1);
     /*printPolySystem_2d(phi_pre);*/  }
 |  exp SMALLEQUAL NUMBER  {
     if ($3 != 0) { yyerror("The right hand need to be zero.\n"); }
     addPoly(phi_pre, $1, 1, -1);
     free($1);
     /*printPolySystem_2d(phi_pre);*/ }
 | exp EQUAL NUMBER  {
     if ($3 != 0) { yyerror("The right hand need to be zero.\n"); }
     addPoly(phi_pre, $1, 1, 1);
     if (phi_or_psi) {
         // = 1, psi
         psi_equals[phi_pre->consNumber[0]] = 1;
         psi_equals[0]++;
     }
     else {
         // = 0, phi
         phi_equals[phi_pre->consNumber[0]] = 1;
         phi_equals[0]++;
     }
     free($1);
     /*printPolySystem_2d(phi_pre);*/  }
 ;

exp: factor { $$ = newpoly_2d(); addMono($$, $1); free($1); /*print_poly_2d($$);*/ }
 | '-' factor { $$ = newpoly_2d(); $2->coefficient = -$2->coefficient; addMono($$, $2); free($2); /*print_poly_2d($$);*/ }
 | exp '+' factor { addMono($1, $3); $$ = $1; free($3); }
 | exp '-' factor { $3->coefficient = -$3->coefficient; addMono($1, $3); $$ = $1; free($3); }
 ;

factor: EXPRESULT { $$ = $1; }
 | factor '*' EXPRESULT {
                         $$ = MergeMono_2d($1, $3);
                         free($1);
                         free($3);
                        }
 ;

EXPRESULT: term { $$ = $1; }
 | term '^' UNEXP {
                 if ($3 > 2) {
                     examine_higher = 1;
                     $$ = MergeMono_2d($1, $1);
                     free($1);
                 }
                 else if ($3 == 2) {
                     $$ = MergeMono_2d($1, $1);
                     free($1);
                 }
                 else if ($3 == 1){
                     $$ = $1;
                 }
                 else {
                     yyerror("Syntax error.\n");
                 }
                }
 ;

term: NUMBER { /*printf("Get a number : %lf.\n", $1);*/ $$ = newMono_coeff($1); }
 | NAME {
         //printf("Get a name : %s.\n", $1);
         int num = newVar($1);
         if (num == varsize) {
             // 新变量
             original_varsize++;
         }
         if (phi_or_psi) {
             variable_psi[num - 1] = 1;
         }
         else {
             variable_phi[num - 1] = 1;
         }
         $$ = newMono_varNum(num);
        }
 | NAME '(' PARALIST ')' {
                         //printf("Meet an uninterpreted function : %s.\n", $1);
                         has_a_euf++;
                         int funcNum;
                         int varNum;

                         Node * temp_ptr = (Node *)malloc(sizeof(Node));
                         N_half_ptr_Initial(temp_ptr);
                         ChangeLinearSyntax1ToSyntax2($3->consNumber, $3->variableNumber, $3->coefficients, temp_ptr->b);

                         //printf("Function exist? %s.\n", funcExist($1)? "Yes" : "No");

                         // 不存在返回0，存在返回编号+1
                         if (funcNum = funcExist($1)) {
                             // 函数已经存在
                             // 验证是否在N_half中
                             // 不存在于N_half中返回0，存在返回编号+1
                             //printf("Function content exist? %s.\n", FuncContentExist(temp_ptr, funcNum, $3->consNumber[0])? "Yes" : "No");
                             if (varNum = FuncContentExist(temp_ptr, funcNum, $3->consNumber[0])){
                                 //varNum--;
                             }
                             else {
                                 // 创建一个新的ptr，添加进N_half
                                 char * newVarName = createNewVar($1, funcNum);
                                 varNum = newVar(newVarName);
                                 ChangeToEUF(temp_ptr, varNum, phi_or_psi, funcVarRef[funcNum - 1],  $3->consNumber[0]);
                                 CombineWithN_half(temp_ptr, funcNum, $3->consNumber[0]);
                                 AddToN_half(temp_ptr, funcNum);
                             }

                         }
                         else {
                             // 函数不存在，是新函数
                             funcNum = newFunc($1);
                             char * newVarName = createNewVar($1, funcNum);
                             varNum = newVar(newVarName);
                             // 添加N_half
                             ChangeToEUF(temp_ptr, varNum, phi_or_psi, funcVarRef[funcNum - 1],  $3->consNumber[0]);
                             AddToN_half(temp_ptr, funcNum);
                         }
                         //printPolySystem_2d($3);
                         if (phi_or_psi){
                             function_list_psi[funcNum - 1] = 1;
                         }
                         else{
                             function_list_phi[funcNum - 1] = 1;
                         }
                         $$ = newMono_varNum(varNum);
                        }
 ;

PARALIST: exp {
    $$ = newpolySystem_2d(phi_or_psi?inputSave[1]->systemName:inputSave[0]->systemName);
    addPoly($$, $1, 1, 1); free($1);
              }
 | PARALIST ',' exp { addPoly($$, $3, 1, 1); free($3); }

%%
/*
main(int argc, char **argv)
{
    varNameList = malloc(sizeof(char *)* 100);
    funcNameList = malloc(sizeof(char *)* 100);
    funcVarRef = malloc(sizeof(int) * 100);
    for (int i = 0; i < 100; i++){
        funcVarRef[i] = 0;
    }
    FILE * f1 = NULL;
    fopen_s(&f1, "E:/myinput.txt", "r+");
    //printf("> ");
    if (f1){
        yyrestart(f1);
        yyparse();
    }
}
*/
yyerror(char *s)
{
    printf("Error at line %d : %s\n", yylineno, s);
    exit(1);
}
