﻿#include "input.h"
#include "printSystem.h"

int funcExist(char * name)
{
	for (int i = 0; i < funcsize; i++){
		if (strcmp(funcNameList[i], name) == 0){
			return i + 1;
		}
	}
	return 0;
}

int varExist(char * name)
{
	for (int i = 0; i < varsize; i++){
		if (strcmp(varNameList[i], name) == 0){
			return i + 1;
		}
	}
	return 0;
}

int newFunc(char * name)
{
	//printf("Create a new function : %s.\n", name);
	int len = strlen(name);
	funcNameList[funcsize] = malloc(sizeof(char)* (len + 1));
	strcpy_s(funcNameList[funcsize], len + 1, name);
	funcsize++;
	return funcsize;
}

char* createNewVar(char * funcname, int funcNum)
{
	int refVarNum = funcVarRef[funcNum - 1];
	//printf("Create a new variable by a function : %s.\n", funcname);
	char * newVarName = malloc(sizeof(char)* (VARNAMESIZE + 3));
	int funcNameLen = strlen(funcname);
	strcpy_s(newVarName, funcNameLen + 1, funcname);
	int length = strlen(funcname);
	newVarName[length] = '%';
	newVarName[length + 1] = (char)('a' + refVarNum / 26);
	newVarName[length + 2] = (char)('a' + refVarNum % 26);
	newVarName[length + 3] = '\0';
	funcVarRef[funcNum - 1]++;
	//printf("The function now has %d references.\n", funcVarRef[funcNum - 1]);
	return newVarName;
}

int newVar(char * name)
{
	int varNumber;
	if (varNumber = varExist(name)){
		return varNumber;
	}
	//printf("Create a new variable : %s.\n", name);
	int len = strlen(name);
	varNameList[varsize] = malloc(sizeof(char)* (len + 1));
	strcpy_s(varNameList[varsize], len + 1, name);
	varsize++;
	return varsize;
}

struct mono* newMono_coeff(double c)
{
	//printf("Create a mono by a coefficient : %lf.\n", c);
	struct mono* re = malloc(sizeof(struct mono));
	re->first = 0;
	re->second = 0;
	re->coefficient = c;
	return re;
}

struct mono* newMono_varNum(int number)
{
	//printf("Create a mono by a variable index : %d.\n", number);
	struct mono* re = malloc(sizeof(struct mono));
	re->first = 0;
	re->second = number;
	re->coefficient = 1.0;
	return re;
}

struct mono* MergeMono_2d(struct mono* a, struct mono* b)
{
	//printf("\nMerge two monos.\n");
	//printf("first mono :\n");
	//printf("%d, %d, %lf\n", a->first, a->second, a->coefficient);
	//printf("second mono :\n");
	//printf("%d, %d, %lf\n", b->first, b->second, b->coefficient);
	struct mono* re = malloc(sizeof(struct mono));
	re->first = 0;
	re->second = 0;
	re->coefficient = 0.0;

	if (a->first != 0){
		if (!mono_insert(re, a->first)) {
			examine_higher = 1;
			return re;
		}
	}
	if (a->second != 0){
		if (!mono_insert(re, a->second)) {
			examine_higher = 1;
			return re;
		}
	}
	if (b->first != 0){
		if (!mono_insert(re, b->first)) {
			examine_higher = 1;
			return re;
		}
	}
	if (b->second != 0){
		if (!mono_insert(re, b->second)) {
			examine_higher = 1;
			return re;
		}
	}

	// 锟缴癸拷
	re->coefficient = a->coefficient * b->coefficient;

	//printf("merge result :\n");
	//printf("%d, %d, %lf\n", re->first, re->second, re->coefficient);
	return re;
}

int mono_insert(struct mono * a, int c)
{
	if (a->second == 0) {
		a->second = c;
		return 1; // 成功
	}
	else if (a->first == 0) {
		if (a->second < c) {
			a->first = a->second;
			a->second = c;
		}
		else {
			a->first = c;
		}
		return 1; // 成功
	}
	else {
		return 0; // 失败
	}
}

void addMono(struct poly_2d* poly, struct mono* newMono)
{
	//printf("\nAdd mono :\n");
	//printf("Origin poly :\n");
	//print_poly_2d(poly);
	//printf("New mono :\n");
	//printf("%d, %d, %lf\n", newMono->first, newMono->second, newMono->coefficient);
	//printf("\n");
	poly->variableNumber[2 * poly->count] = newMono->first;
	poly->variableNumber[2 * poly->count + 1] = newMono->second;
	poly->coefficients[poly->count] = newMono->coefficient;
	poly->count++;

	//printf("New poly :\n");
	//print_poly_2d(poly);
}

struct poly_2d* newpoly_2d()
{
	struct poly_2d *sen = (struct poly_2d*) malloc(sizeof(struct poly_2d));
	sen->variableNumber = (int *)malloc(sizeof(int)* MONOSIZE * 2);
	sen->coefficients = (double *)malloc(sizeof(double)* MONOSIZE);
	sen->count = 0;
	return sen;
}

void print_poly_2d(struct poly_2d *t)
{
	for (int i = 0; i < t->count; i++) {
		printf("%lf, %d, %d\n", t->coefficients[i], t->variableNumber[2*i], t->variableNumber[2*i + 1]);
	}
	printf("\n");
}

/* Polynomial System*/

void addPoly(struct polySystem_2d* polySys, struct poly_2d* newPoly, int strict_flag, int big_small_flag)
{
	int num = polySys->consNumber[0];
	polySys->consNumber[num + 1] = strict_flag * newPoly->count;
	polySys->variableNumber[num] = newPoly->variableNumber;
	polySys->coefficients[num] = newPoly->coefficients;
	for (int i = 0; i < newPoly->count; i++){
		newPoly->coefficients[i] = big_small_flag * newPoly->coefficients[i];
	}
	polySys->consNumber[0]++;
}

struct polySystem_2d* newpolySystem_2d(char * systemName)
{
	//printf("Create a new poly system by a name : %s.\n", systemName);
	struct polySystem_2d *phi = (struct polySystem_2d*) malloc(sizeof(struct polySystem_2d));
	phi->variableNumber = (int **)malloc(sizeof(int *)* MONOSIZE * 2);
	phi->coefficients = (double **)malloc(sizeof(double *)* MONOSIZE);
	phi->consNumber = (int *)malloc(sizeof(int)* (MONOSIZE + 1));
	phi->conj = NULL;
	phi->next = NULL;
	phi->with = NULL;
	phi->trueValue = 2;
	phi->consNumber[0] = 0;
	phi->systemName = malloc(sizeof(char)* VARNAMESIZE);
	strcpy_s(phi->systemName, strlen(systemName) + 1, systemName);
	return phi;
}

void printPolySystem_2d(struct polySystem_2d* polySys)
{
	if (polySys == NULL || polySys->consNumber == NULL){
		printf("None.\n");
		return;
	}
	printf("%s :\n", polySys->systemName);
	if (polySys->consNumber[0] == 0){
		printf("True.\n");
		return;
	}
	int num = polySys->consNumber[0];
	//printf("This poly system's name is %s.\n", polySys->systemName);
	//printf("It has %d polynomials.\n", num);

	//varNameList修正
	for (int i = 0; i < funcsize; i++){
		Node * tempNode = N_half[i];
		while (tempNode != NULL){
			int numberOfVar = tempNode->a[0] - 1;
			varNameList[numberOfVar] = realloc(varNameList[numberOfVar], sizeof(char)* 200);
			sprintf(varNameList[numberOfVar], "%s(", funcnamelist[i]);
			int ret1 = strlen(funcnamelist[i]) + 1;
			char * receiveChar = (char *)malloc(sizeof(char)* 200);
			int notFirstOne = 0;
			for (int j = 0; j <= varsize; j++){
				if (tempNode->b[0][j] != 0){
					if (tempNode->b[0][j] > 0 && notFirstOne){
						varNameList[numberOfVar][ret1] = '+';
						ret1++;
					}
					sprintf(receiveChar, "%.6lf", (double)tempNode->b[0][j] / (double)tempNode->b[1][j]);
					for (int k = 0; k < 8; k++){
						varNameList[numberOfVar][k + ret1] = receiveChar[k];
					}
					ret1 += 8;
					if (j != 0){
						varNameList[numberOfVar][ret1] = '*';
						ret1++;
					}
					if (j != 0){
						for (int k = 0; k < strlen(varNameList[j - 1]); k++){
							varNameList[numberOfVar][k + ret1] = varNameList[j - 1][k];
						}
						ret1 += strlen(varNameList[j - 1]);
					}
					notFirstOne = 1;
				}
			}
			varNameList[numberOfVar][ret1] = ')';
			ret1++;
			varNameList[numberOfVar][ret1] = '\0';
			tempNode = tempNode->next;
		}
	}


	for (int i = 0; i < polySys->consNumber[0]; i++){
		if (polySys->consNumber[i + 1] > 0){
			for (int j = 0, k = 0; j < polySys->consNumber[i + 1]; j++){
				if (k == 1 && polySys->coefficients[i][j] > 0)
					printf(" +");
				else
					printf(" ");
				k = 1;
				if (polySys->variableNumber[i][2 * j] == polySys->variableNumber[i][2 * j + 1]){
					if (polySys->variableNumber[i][2 * j] == 0){
						printf("%.6lf", polySys->coefficients[i][j]);
					}
					else{
						printf("%.6lf*%s^2", polySys->coefficients[i][j], varNameList[polySys->variableNumber[i][2 * j] - 1]);

					}
				}
				else{
					if (polySys->variableNumber[i][2 * j] == 0){
						printf("%.6lf*%s", polySys->coefficients[i][j], varNameList[polySys->variableNumber[i][2 * j + 1] - 1]);
					}
					else if (polySys->variableNumber[i][2 * j + 1] == 0){
						printf("%.6lf*%s", polySys->coefficients[i][j], varNameList[polySys->variableNumber[i][2 * j] - 1]);
					}
					else{
						printf("%.6lf*%s*%s", polySys->coefficients[i][j], varNameList[polySys->variableNumber[i][2 * j] - 1], varNameList[polySys->variableNumber[i][2 * j + 1] - 1]);
					}
				}
			}

			if (strcmp(polySys->systemName, inputSave[0]->systemName) && phi_equals[i + 1]) {
				printf(" = 0\n");
			}
			else if (strcmp(polySys->systemName, inputSave[1]->systemName) && psi_equals[i + 1]) {
				printf(" = 0\n");
			}
			else {
				printf(" >= 0\n");
			}
		}
		else{
			for (int j = 0, k = 0; j < -polySys->consNumber[i + 1]; j++){
				if (k == 1 && polySys->coefficients[i][j] > 0)
					printf(" +");
				else
					printf(" ");
				k = 1;
				if (polySys->variableNumber[i][2 * j] == polySys->variableNumber[i][2 * j + 1]){
					if (polySys->variableNumber[i][2 * j] == 0){
						printf("%.6lf", polySys->coefficients[i][j]);
					}
					else
						printf("%.6lf*%s^2", polySys->coefficients[i][j], varNameList[polySys->variableNumber[i][2 * j] - 1]);
				}
				else{
					if (polySys->variableNumber[i][2 * j] == 0){
						printf("%.6lf*%s", polySys->coefficients[i][j], varNameList[polySys->variableNumber[i][2 * j + 1] - 1]);
					}
					else if (polySys->variableNumber[i][2 * j + 1] == 0){
						printf("%.6lf*%s", polySys->coefficients[i][j], varNameList[polySys->variableNumber[i][2 * j] - 1]);
					}
					else{
						printf("%.6lf*%s*%s", polySys->coefficients[i][j], varNameList[polySys->variableNumber[i][2 * j] - 1], varNameList[polySys->variableNumber[i][2 * j + 1] - 1]);
					}
				}
			}
			printf(">0");
		}
		printf("\n\n");
	}

	return;
}

void CopyPolySystemToNode(struct polySystem_2d* polySys, Node * phi)
{
	NodeInitial(phi);
	phi->a[0] = polySys->consNumber[0];
	for (int i = 0; i < phi->a[0]; i++){
		phi->a[i + 1] = polySys->consNumber[i + 1];

		int termNum = phi->a[i + 1] >0 ? phi->a[i + 1] : -phi->a[i + 1];
		for (int j = 0; j < termNum; j++){
			phi->b[i][2 * j] = polySys->variableNumber[i][2 * j];
			phi->b[i][2 * j + 1] = polySys->variableNumber[i][2 * j + 1];
			phi->c[i][j] = polySys->coefficients[i][j];
		}
	}
	phi->trueValue = 2;
}

void CopyNameList()
{
	int len;
	varnamelist = malloc(sizeof(char *)* 100);
	for (int i = 0; i < varsize; i++){
		len = strlen(varNameList[i]);
		varnamelist[i] = malloc(sizeof(char)* VARNAMESIZE);
		strcpy_s(varnamelist[i], len + 1, varNameList[i]);
	}
	funcnamelist = malloc(sizeof(char *)* 100);
	for (int i = 0; i < funcsize; i++){
		len = strlen(funcNameList[i]);
		funcnamelist[i] = malloc(sizeof(char)* VARNAMESIZE);
		strcpy_s(funcnamelist[i], len + 1, funcNameList[i]);
	}
}

void ChangePhiPsiOutput()
{
	if (phipsiOutput[phipsiOutputCapacity - 1] != '\n') {
		phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, "\n");
		phipsiOutput[phipsiOutputCapacity] = '\0';
	}
}

void newInputFunction(const char * myfilename, Node * phi_constraints, Node *psi_constraints)
{
	FILE * fp = NULL;
	fopen_s(&fp, myfilename, "r+");
	if (fp == NULL){
		printf("The file doesn't exist.");
		exit(1);
	}

	yyrestart(fp);
	yyparse();

	ChangePhiPsiOutput();

	if (examine_higher) {
		if (webVersion){
			solve_higher_problem_for_web(myfilename);
			exit(666);
		}
		else{
			printf("%s", phipsiOutput);
			solve_higher_problem(myfilename);
			exit(2);
		}
	}

	//OutputVarNameList();

	CopyNameList();

	CopyPolySystemToNode(inputSave[0], phi_constraints);
	CopyPolySystemToNode(inputSave[1], psi_constraints);

	//printPolySystem_2d(inputSave[0]);
	//printf("=====================\n");
	//printPolySystem_2d(inputSave[1]);
	//printf("=====================\n");
	//OutputH_half();
	//OutputH_total();

	//printSystem(phi_constraints);
	//printSystem(psi_constraints);

	//system("Pause");
}

void InputInitial()
{
	inputSave = malloc(sizeof(struct polySystem_2d *) * 2);
	inputSave[0] = NULL;
	inputSave[1] = NULL;

	function_list_common = (int *)malloc(sizeof(int)* MY_MALLOC_SIZE);
	function_list_phi = (int *)malloc(sizeof(int)* MY_MALLOC_SIZE);
	function_list_psi = (int *)malloc(sizeof(int)* MY_MALLOC_SIZE);
	for (int i = 0; i < MY_MALLOC_SIZE; i++){
		function_list_common[i] = 0;
		function_list_phi[i] = 0;
		function_list_psi[i] = 0;
	}

	variable_common = (int *)malloc(sizeof(int)* VARSIZE_MAXIMUM);
	variable_phi = (int *)malloc(sizeof(int)* VARSIZE_MAXIMUM);
	variable_psi = (int *)malloc(sizeof(int)* VARSIZE_MAXIMUM);
	for (int i = 0; i < VARSIZE_MAXIMUM; i++){
		variable_common[i] = 0;
		variable_phi[i] = 0;
		variable_psi[i] = 0;
	}

	phipsiOutput = (char *)malloc(sizeof(char)* 2000);

	N_half = (Node **)malloc(sizeof(Node *)* MY_MALLOC_SIZE);
	for (int i = 0; i < MY_MALLOC_SIZE; i++){
		N_half[i] = NULL;
	}
}

void NodeInitial(Node * phi)
{
	phi->a = malloc(sizeof(int)* 101);
	phi->b = malloc(sizeof(int *)* 100);
	for (int i = 0; i < 100; i++){
		phi->b[i] = malloc(sizeof(int)* 200);
	}
	phi->c = malloc(sizeof(double *)* 100);
	for (int i = 0; i < 100; i++){
		phi->c[i] = malloc(sizeof(double)* 100);
	}
	phi->conj = NULL;
	phi->next = NULL;
	phi->with = NULL;
	phi->a[0] = 0;
	//return phi;
}

void OutputVarNameList()
{
	printf("Variable name list :\n");
	for (int i = 0; i < varsize; i++){
		printf("%s\n", varNameList[i]);
	}
	printf("\n");
}

void Output_varname_list()
{
	printf("Variable name list :\n");
	for (int i = 0; i < varsize; i++){
		printf("%s\n", varnamelist[i]);
	}
	printf("\n");
}

// func_num_temp函数的编号，NvarFunc函数的变元个数
int FuncContentExist(Node * new_ptr, int func_num_temp, int NvarFunc)
{
	// 其实就是检查N_half

	int * qresult;
	int appeared_num = 0;
	Node * search_ptr;
	if ((search_ptr = N_half[func_num_temp - 1]) != NULL){
		do{
			int this_has_been_appeared = 1;
			for (int pp = 0; pp < NvarFunc; pp++){
				for (int ii = 0; ii <= varsize; ii++){
					qresult = fraction_add(new_ptr->b[2 * pp][ii], new_ptr->b[2 * pp + 1][ii],
						-search_ptr->b[2 * pp][ii], search_ptr->b[2 * pp + 1][ii]);
					if (qresult[0] != 0){
						this_has_been_appeared = 0;
						break;
					}
					free(qresult);
				}
			}
			if (this_has_been_appeared == 1){
				appeared_num = search_ptr->a[0]; // 记录的f对应的变量id+1
				return appeared_num;
			}
			if (search_ptr->next != NULL){
				search_ptr = search_ptr->next;
			}
			else {
				break;
			}
		} while (1);
	}
	return 0;
}

// num0是新变量的编号，num1是函数的系统归属，num2是函数引用的次数，num3是函数的变元个数
Node * ChangeToEUF(Node * new_ptr, int num0, int num1, int num2, int num3)
{
	new_ptr->a[0] = num0;
	if (num1) {
		new_ptr->a[1] = -1;
	}
	else {
		new_ptr->a[1] = 1;
	}
	new_ptr->a[2] = num2;
	new_ptr->a[3] = num3;

	return new_ptr;
}

void ChangeLinearSyntax1ToSyntax2(int * a1, int ** b1, double ** c1, int ** b2)
{
	int num = a1[0];
	int varNumber;
	int * qresult = malloc(sizeof(int)* 2);
	for (int i = 0; i < num; i++){
		for (int j = 0; j < a1[i + 1]; j++){
			varNumber = b1[i][2 * j + 1];
			qresult = ftoq(c1[i][j]);
			b2[2 * i][varNumber] = qresult[0];
			b2[2 * i + 1][varNumber] = qresult[1];
		}
	}
}

void N_half_ptr_Initial(Node * new_ptr)
{
	new_ptr->a = (int *)malloc(sizeof(int)* 4);
	for (int a_i = 0; a_i < 4; a_i++){
		new_ptr->a[a_i] = 0;
	}
	new_ptr->b = (int **)malloc(sizeof(int *)* 2 * MY_MALLOC_SIZE);//由于varsize会不停的变化，我也不知该开多大的数组
	for (int pp = 0; pp < MY_MALLOC_SIZE; pp++){
		new_ptr->b[2 * pp] = (int *)malloc(sizeof(int)* VARSIZE_MAXIMUM);
		for (int i = 0; i < VARSIZE_MAXIMUM; i++){
			new_ptr->b[2 * pp][i] = 0;
		}
		new_ptr->b[2 * pp + 1] = (int *)malloc(sizeof(int)* VARSIZE_MAXIMUM);
		for (int i = 0; i < VARSIZE_MAXIMUM; i++){
			new_ptr->b[2 * pp + 1][i] = 1;
		}
	}
	new_ptr->next = NULL;
}

void N_total_ptr_Initial(Node * N_new)
{
	N_new->a = (int *)malloc(sizeof(int)* 9); //a中存蕴含式后边的元素
	for (int a_i = 0; a_i < 3; a_i++){
		N_new->a[a_i] = 0;
	}
	N_new->b = (int **)malloc(sizeof(int *)* 2 * MY_MALLOC_SIZE);//由于varsize会不停的变化，我也不知该开多大的数组
	for (int pp = 0; pp < MY_MALLOC_SIZE; pp++){
		N_new->b[2 * pp] = (int *)malloc(sizeof(int)* VARSIZE_MAXIMUM);
		for (int i = 0; i < VARSIZE_MAXIMUM; i++){
			N_new->b[2 * pp][i] = 0;
		}
		N_new->b[2 * pp + 1] = (int *)malloc(sizeof(int)* VARSIZE_MAXIMUM);
		for (int i = 0; i < VARSIZE_MAXIMUM; i++){
			N_new->b[2 * pp + 1][i] = 1;
		}
	}
}

void CombineWithN_half(Node * temp_ptr, int funcNum, int NvarFunc)
{
	int * qresult;
	Node *old_ptr = N_half[funcNum - 1];
	Node * N_new = (Node *)malloc(sizeof(Node));
	N_total_ptr_Initial(N_new);
	while (old_ptr != NULL){
		for (int pp = 0; pp < NvarFunc; pp++){
			for (int ii = 0; ii <= varsize; ii++){
				qresult = fraction_add(temp_ptr->b[2 * pp][ii], temp_ptr->b[2 * pp + 1][ii],
					-old_ptr->b[2 * pp][ii], old_ptr->b[2 * pp + 1][ii]);
				N_new->b[2 * pp][ii] = qresult[0];
				N_new->b[2 * pp + 1][ii] = qresult[1];
				free(qresult);
			}
		}
		N_new->a[0] = old_ptr->a[0];
		N_new->a[1] = temp_ptr->a[0];
		N_new->a[2] = temp_ptr->a[1];
		N_new->a[3] = old_ptr->a[1];
		N_new->a[4] = varsize;
		N_new->a[5] = NvarFunc;
		N_new->a[6] = temp_ptr->a[2];
		N_new->a[7] = old_ptr->a[2];
		N_new->a[8] = funcNum - 1;

		if (N_new->a[2] == 1){
			if (N_new->a[3] == 1){
				N_new->next = N_phi;
				N_phi = N_new;
			}
			else{
				N_new->next = N_mix;
				N_mix = N_new;
			}
		}
		else{
			if (N_new->a[3] == -1){
				N_new->next = N_psi;
				N_psi = N_new;
			}
			else{
				N_new->next = N_mix;
				N_mix = N_new;
			}
		}
		old_ptr = old_ptr->next;
	}
}

void AddToN_half(Node * temp_ptr, int funcNum)
{
	//printf("Add to N_half[%d].\n", funcNum - 1);
	Node * old_ptr = N_half[funcNum - 1];
	if (old_ptr) {
		while (old_ptr->next) {
			old_ptr = old_ptr->next;
		}
		temp_ptr->next = NULL;
		old_ptr->next = temp_ptr;
	}
	else {
		N_half[funcNum - 1] = temp_ptr;
		temp_ptr->next = NULL;
	}
}

void OutputH_half()
{
	for (int i = 0; i < 5; i++){
		printf("==============================\n");
		if (N_half[i] == NULL){
			printf("N_half[%d] is NULL.\n", i);
		}
		else{
			printf("N_half[%d] are :\n",i);
			Node * temp_ptr = N_half[i];
			while (temp_ptr){
				printf("Variable [%s] :\n", varnamelist[temp_ptr->a[0] - 1]);
				printf("belongs to [%s] :\n", temp_ptr->a[1]==1?"phi":"psi");
				printf("References [%d] :\n", temp_ptr->a[2]);
				temp_ptr = temp_ptr->next;
			}
		}
	}
	printf("==============================\n");
}

void OutputH_total()
{
	Node * temp;
	printf("=============N_phi=============\n");
	if ((temp = N_phi) == NULL) {
		printf("N_phi is NULL.\n");
	}
	else {
		while (temp != NULL){
			printEntailFormula(temp);
			temp = temp->next;
		}
	}
	printf("=============N_psi=============\n");
	if ((temp = N_psi) == NULL) {
		printf("N_psi is NULL.\n");
	}
	else {
		while (temp != NULL){
			printEntailFormula(temp);
			temp = temp->next;
		}
	}
	printf("=============N_mix=============\n");
	if ((temp = N_mix) == NULL) {
		printf("N_mix is NULL.\n");
	}
	else {
		while (temp != NULL){
			printEntailFormula(temp);
			temp = temp->next;
		}
	}
}
