%option noyywrap nodefault yylineno
%x EXPONENT
%{
#include "unistd.h"
#include "cal.tab.h"
#include "input.h"
int systemNumber;
%}

%%
"+" |
"-" |
"*" |
"\(" |
"\)" |
"," {
	phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, yytext);
	return yytext[0];
	}

"\^" {
	  BEGIN EXPONENT;
	  phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, yytext);
	  return yytext[0];
	 }

">" {
	phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, yytext);
	return BIG;
	}

">=" {
	phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, yytext);
	return BIGEQUAL;
	 }

"<" {
	yyerror("Syntax error.\n");
//	phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, yytext);
//	return SMALL;
	}

"<=" {
	yyerror("Syntax error.\n");
//	phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, yytext);
//	return SMALLEQUAL;
	 }

"=" {
	phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, yytext);
	return EQUAL;
	}

<EXPONENT>[-]?[0-9]+ {
					phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, yytext);
				  	yylval.exponent = atoi(yytext);
				  	BEGIN INITIAL;
				  	return UNEXP;
			  	 	 }

([0-9]+\.?[0-9]*|\.[0-9]+)([Ee][+-][0-9]+)? {
	phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, yytext);
	yylval.number = atof(yytext);
	return NUMBER;
											}

[_a-zA-Z][_0-9a-zA-Z]* {
						phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, yytext);
	 					 yylval.name = (char *)malloc(sizeof(char)*VARNAMESIZE);
						 strcpy_s(yylval.name, strlen(yytext)+1, yytext);
						 return NAME;
					   }

[_a-zA-Z][_0-9a-zA-Z]*: {
						if (systemNumber){
							phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, "\n");
						}
						else {
							systemNumber++;
						}
						phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, yytext);
			 			yylval.name = (char *)malloc(sizeof(char)*VARNAMESIZE);
					   	strcpy_s(yylval.name, strlen(yytext) + 1, yytext);
					   	return TITLE;
					   }

[\n]+ { phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, "\n"); return EOL;}
<<EOF>> { phipsiOutput[phipsiOutputCapacity] = '\0'; yyterminate(); }
"//".*
"#".*
[ \t\r] { }
. {yyerror("Syntax error.\n");}
%%
